#define INCL_WIN
#define INCL_GPI
#include <os2.h>
#include "blter.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY ClientWndProc( HWND, ULONG, MPARAM, MPARAM );
VOID GetAndStoreBMP( HWND, HPS );
VOID DisplayMessage ( HWND, PSZ );
VOID CheckMenuItem( HWND, SHORT *, SHORT );


/* global variables */
HAB     hab;
HWND    hwndFrame;
HBITMAP hbm = 0;
POINTL apts[4];
LONG   aROP[] = { ROP_SRCCOPY,
                  ROP_SRCPAINT,
                  ROP_SRCAND,
                  ROP_SRCINVERT,
                  ROP_SRCERASE,
                  ROP_NOTSRCCOPY,
                  ROP_NOTSRCERASE,
                  ROP_MERGECOPY,
                  ROP_MERGEPAINT,
                  ROP_PATCOPY,
                  ROP_PATPAINT,
                  ROP_PATINVERT,
                  ROP_DSTINVERT,
                  ROP_ZERO,
                  ROP_ONE
                };
ULONG aCLR[] = { CLR_BLACK,
                 CLR_RED,
                 CLR_GREEN,
                 CLR_BLUE,
                 CLR_WHITE
               };


INT main( VOID )
{
   HMQ   hmq;
   HWND  hwndClient;
   QMSG  qmsg;
   CHAR  szClientClass[] = "Client Window";
   ULONG flCreateFlags = FCF_TITLEBAR      /* create: title bar control     */
                       | FCF_SYSMENU       /*         system menu control   */
                       | FCF_MENU          /*         action bar            */
                       | FCF_MINMAX        /*         min and max buttons   */
                       | FCF_SIZEBORDER    /* draw sizeborders              */
                       | FCF_SHELLPOSITION /* shell decides window position */
                       | FCF_TASKLIST      /* title added to switch list    */
                       | FCF_ICON;         /* frame has an icon             */

   hab = WinInitialize(0);

   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,            /* anchor block handle */
                     szClientClass,  /* class name */
                     ClientWndProc,  /* pointer to window procedure */
                     CS_SIZEREDRAW,  /* class style */
                     0 );            /* number of class data bytes */

   hwndFrame = WinCreateStdWindow(
                HWND_DESKTOP,            /* Desktop window is parent     */
                WS_VISIBLE,              /* window styles                */
                &flCreateFlags,          /* frame control flag           */
                szClientClass,           /* client window class name     */
                "GpiBitBlt Tester",      /* title bar text               */
                0,                       /* no special class style       */
                NULLHANDLE,              /* resource is in .EXE file     */
                ID_FRAME_RES,            /* frame window identifier      */
                &hwndClient              /* client window handle         */
                );

   if ( hwndFrame )
      while (WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndFrame );   /* clean up */
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY ClientWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   static SHORT  sClientX, sClientY;    /* client window X and Y dimensions */
   static SHORT  sOrient = IDM_NORMAL;  /* use normal orientation */
   static SHORT  sROP    = IDM_SRCCOPY; /* use ROP_SRCCOPY */
   static SHORT  sCLR    = IDM_BLACK;   /* target color */
   static HPS    hpsMemory;
   static HDC    hdcMemory;

   switch( msg ) {

      case WM_CREATE:
       { SIZEL  sizl;

         hdcMemory = DevOpenDC(
                        hab,
                        OD_MEMORY,
                        "*",
                        0L,
                        NULL,
                        NULLHANDLE);

         sizl.cx = sizl.cy = 0 ;

         hpsMemory = GpiCreatePS(
                        hab,
                        hdcMemory,
                        &sizl,
                        PU_PELS | GPIF_DEFAULT | GPIT_MICRO | GPIA_ASSOC );

         apts[2].x = apts[2].y = 0;

       } break;

      case WM_COMMAND:

         /* if it is an ROP menu item */
         if ( (SHORT1FROMMP(mp1) >= IDM_SRCCOPY )
              && ( SHORT1FROMMP(mp1) <= IDM_ONE ) ) {
            CheckMenuItem( WinWindowFromID( hwndFrame, FID_MENU ),
                           &sROP,
                           SHORT1FROMMP(mp1) );
            WinInvalidateRect(hwnd, NULL, FALSE);

         /* else if it is an Orientation menu item */
         } else if (( SHORT1FROMMP(mp1) >= IDM_NORMAL )
                   && ( SHORT1FROMMP(mp1) <= IDM_INVERTXY )) {
            CheckMenuItem( WinWindowFromID( hwndFrame, FID_MENU ),
                           &sOrient,
                           SHORT1FROMMP(mp1) );
            WinInvalidateRect(hwnd, NULL, FALSE);

         /* else if it is a Background menu item */
         } else if (( SHORT1FROMMP(mp1) >= IDM_BLACK )
                   && ( SHORT1FROMMP(mp1) <= IDM_WHITE )) {
            CheckMenuItem( WinWindowFromID( hwndFrame, FID_MENU ),
                           &sCLR,
                           SHORT1FROMMP(mp1) );
            WinInvalidateRect(hwnd, NULL, FALSE);

         /* else if it is the Open menu item */
         } else if (SHORT1FROMMP(mp1) == IDM_OPEN) {
                   GetAndStoreBMP(hwnd, hpsMemory);
                   WinInvalidateRect(hwnd, NULL, FALSE);

         /* else no match */
         } else
            return WinDefWindowProc( hwnd, msg, mp1, mp2 );
         break;

      case WM_ERASEBACKGROUND:
         return (MRESULT)TRUE;

      case WM_PAINT:
       { HPS    hps;
         RECTL  rcl;

         hps = WinBeginPaint(hwnd, NULLHANDLE, &rcl);

         WinFillRect( hps, &rcl, aCLR[sCLR - IDM_BLACK] );

         GpiSetPattern(hps, PATSYM_DIAG1);

         switch (sOrient) {

            case IDM_NORMAL:
               apts[0].x = apts[0].y = 0;     /* Target X left and Y bot  */
               apts[1].x = (LONG)sClientX;    /* Target X right           */
               apts[1].y = (LONG)sClientY;    /* Target Y top             */
               break;

            case IDM_INVERTX:
               apts[0].y = 0;                 /* Target Y bottom          */
               apts[1].y = (LONG)sClientY;    /* Target Y top             */
               apts[0].x = (LONG)sClientX;    /* Target X left            */
               apts[1].x = 0;                 /* Target X right           */
               break;

            case IDM_INVERTY:
               apts[0].x = 0;                 /* Target X left            */
               apts[1].x = (LONG)sClientX;    /* Target X right           */
               apts[0].y = (LONG)sClientY;    /* Target Y bottom          */
               apts[1].y = 0;                 /* Target Y top             */
               break;

            case IDM_INVERTXY:
               apts[0].x = (LONG)sClientX;    /* Target X right           */
               apts[0].y = (LONG)sClientY;    /* Target Y top             */
               apts[1].x = apts[1].y = 0;     /* Target X left and Y bot  */
               break;
         }

         GpiBitBlt( hps,
                    hpsMemory,
                    4L,
                    (PPOINTL)apts,
                    aROP[ sROP - IDM_SRCCOPY ],
                    BBO_IGNORE);

         WinEndPaint(hps);

       } break;

      case WM_SIZE:
        sClientX = (LONG)SHORT1FROMMP(mp2);
        sClientY = (LONG)SHORT2FROMMP(mp2);
        break;

      case WM_DESTROY:
        GpiDestroyPS(hpsMemory);
        DevCloseDC(hdcMemory);
        GpiDeleteBitmap(hbm);
        break;

      default:
        return WinDefWindowProc( hwnd, msg, mp1, mp2 );
   }

   return (MRESULT)FALSE;
} /* end of ClientWndProc */


VOID GetAndStoreBMP( HWND hwndClient, HPS hpsMem )
{
   FILEDLG     FileDlg;
   HWND        hwndDlg;
   HFILE       FileHandle;
   ULONG       ulAction;
   ULONG       cbRead;
   FILESTATUS  FileInfo;
   PBYTE       pFileBegin = NULL;  /* beginning of bitmap file data */
   HPS         hps;
   PBITMAPFILEHEADER2 pbfh2;
   PBITMAPINFOHEADER2 pbmp2;
   CHAR szBuffer[50];
   APIRET  rc;
   ERRORID err;

   memset( &FileDlg, 0, sizeof(FILEDLG) );

   FileDlg.cbSize   = sizeof(FILEDLG);
   FileDlg.fl       = FDS_HELPBUTTON | FDS_CENTER | FDS_OPEN_DIALOG;
   FileDlg.pszTitle = "Open A BMP File";

   strcpy(FileDlg.szFullFile, "*.bmp");

   hwndDlg = WinFileDlg(HWND_DESKTOP, hwndClient, (PFILEDLG)&FileDlg);

   rc = DosOpen(FileDlg.szFullFile,
                &FileHandle,
                &ulAction,
                0,
                FILE_NORMAL,
                FILE_OPEN,
                OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE,
                NULL);

   if (rc) {
      sprintf(szBuffer, "DosOpen failed");
      DisplayMessage(hwndClient, szBuffer);
      return;
   }

   rc = DosQueryFileInfo(FileHandle,
                         FIL_STANDARD,
                         &FileInfo,
                         sizeof(FileInfo));

   if (rc) {
      sprintf(szBuffer, "DosQueryFileInfo failed");
      DisplayMessage(hwndClient, szBuffer);
      return;
   }

   rc = DosAllocMem((PPVOID) &pFileBegin,
                    (ULONG)  FileInfo.cbFile,
                    (ULONG)  PAG_READ | PAG_WRITE | PAG_COMMIT);

   if (rc) {
      sprintf(szBuffer, "DosAllocMem failed");
      DisplayMessage(hwndClient, szBuffer);
      return;
   }

   rc = DosRead( FileHandle,
                 (PVOID)pFileBegin,
                 FileInfo.cbFile,
                 &cbRead);

   if (rc) {
      sprintf(szBuffer, "DosRead failed");
      DisplayMessage(hwndClient, szBuffer);
      return;
   }

   if ( *((PUSHORT)pFileBegin) == BFT_BITMAPARRAY)
      pbfh2 =(PBITMAPFILEHEADER2)&((PBITMAPARRAYFILEHEADER2)pFileBegin)->bfh2;
   else
      pbfh2 =(PBITMAPFILEHEADER2)pFileBegin;

   pbmp2 = &pbfh2->bmp2;    /* pointer to info header (readability) */

   hps = WinGetPS(hwndClient);

   if (hbm)
      GpiDeleteBitmap(hbm);

   hbm = GpiCreateBitmap(
            hps,
            pbmp2,                 /* BITMAPINFOHEADER2 */
            CBM_INIT,              /* options */
            (PBYTE)pFileBegin      /* address of bitmap data */
            + pbfh2->offBits,
            (PBITMAPINFO2)pbmp2 ); /* structure for color and format */

   WinReleasePS(hps);

   if (!hbm) {
      err = WinGetLastError(hab);
      sprintf(szBuffer, "GpiLoadBitmap failed with a rc of %ld", err );
      DisplayMessage(hwndClient, szBuffer);
   }

   GpiSetBitmap(hpsMem, hbm);

   if (pbmp2->cbFix == sizeof(BITMAPINFOHEADER)) {
      apts[3].x = (LONG)((PBITMAPINFOHEADER)pbmp2)->cx;
      apts[3].y = (LONG)((PBITMAPINFOHEADER)pbmp2)->cy;
   } else {
      apts[3].x = pbmp2->cx;
      apts[3].y= pbmp2->cy;
   }

   DosFreeMem( pFileBegin);
   DosClose( FileHandle);
} /* end of GetAndStoreBMP */


VOID DisplayMessage ( HWND hwndOwner, PSZ pszText  )
{

   WinMessageBox ( HWND_DESKTOP,
                   hwndOwner,
                   pszText,
                   "GpiBitBlt Example",
                   0,
                   MB_OK );
} /* end of DisplayMessage */


VOID CheckMenuItem( HWND hwndMenu, SHORT *psPrev, SHORT sNew )
{
   WinSendMsg( hwndMenu,
               MM_SETITEMATTR,
               MPFROM2SHORT( *psPrev, TRUE ),
               MPFROM2SHORT( MIA_CHECKED, 0 ));
   *psPrev = sNew;
   WinSendMsg( hwndMenu,
               MM_SETITEMATTR,
               MPFROM2SHORT( *psPrev, TRUE ),
               MPFROM2SHORT ( MIA_CHECKED, MIA_CHECKED ));
} /* end of CheckMenuItem */
