#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include "circles.h"

/* prototypes */
INT main( VOID );
MRESULT EXPENTRY ClientWndProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY MyDlgProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
HAB     hab;
HWND    hwndClient;
POINTL  aPtl[3];
SHORT   Radius;
ARCPARAMS arcp = { 1, 1, 0, 0 };
LONG aColors[] = {  0x00FF0000L, 0x0000FF00L, 0x000000FFL };
                    /*  red        green         blue  */


INT main( VOID )
{
   HMQ   hmq;
   QMSG  qmsg;
   HWND  hwndFrame;
   HWND  hwndDlg;
   static CHAR szClientClass[] = "Client Window";
   ULONG flCreateFlags = FCF_TITLEBAR      /* create: title bar control     */
                       | FCF_SYSMENU       /*         system menu control   */
                       | FCF_MINMAX        /*         min and max buttons   */
                       | FCF_SIZEBORDER    /* draw sizeborders              */
                       | FCF_SHELLPOSITION /* shell decides window position */
                       | FCF_TASKLIST      /* title added to switch list    */
                       | FCF_ICON;         /* frame has an icon             */

   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,            /* anchor block handle */
                     szClientClass,  /* class name */
                     ClientWndProc,  /* pointer to window procedure */
                     CS_SIZEREDRAW | CS_SYNCPAINT,  /* class style */
                     0 );            /* number of class data bytes */

   hwndFrame = WinCreateStdWindow(
                  HWND_DESKTOP,   /* parent */
                  0,              /* use default frame window style */
                  &flCreateFlags, /* creation flags for frame window */
                  szClientClass,  /* client window class name */
                  "Circles",      /* text added to title */
                  0,              /* use default client window style */
                  NULLHANDLE,     /* resource ID's are in rc file */
                  ID_CIRCLES,     /* ID for frame window */
                  &hwndClient );  /* address to place client window handle */

   if (hwndFrame) {
      WinShowWindow( hwndFrame, TRUE );

      hwndDlg = WinLoadDlg( HWND_DESKTOP,      /* Parent */
                            hwndFrame,         /* Owner */
                            (PFNWP)MyDlgProc,
                            NULLHANDLE,
                            ID_DLGBOX,
                            NULL
                          );
      if ( hwndDlg)
         while (WinGetMsg(hab,&qmsg, NULLHANDLE, 0, 0 ))
            WinDispatchMsg(hab, &qmsg);
   }

   WinDestroyWindow( hwndFrame );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY ClientWndProc( HWND hwnd, ULONG msg, MPARAM mp1,MPARAM mp2 )
{
   static HDC hdc;
   static HPS hps;
   static SIZEL sizl = { 0, 0 };

   switch (msg) {

   case WM_SIZE:
    { SHORT x,y, xTrans, yTrans;

      x = (SHORT)( SHORT1FROMMP(mp2) / 4 );
      y = (SHORT)( SHORT2FROMMP(mp2) / 4 );  //5
      Radius = ( x > y ? y : x );
      xTrans = (SHORT)( (SHORT1FROMMP(mp2)-3*Radius)/2 );
      yTrans = (SHORT)( (SHORT2FROMMP(mp2)-3*Radius)/2 );
      aPtl[0].x = Radius + xTrans;              aPtl[0].y = 2*Radius + yTrans;
      aPtl[1].x = (SHORT)(1.5*Radius) + xTrans; aPtl[1].y =   Radius + yTrans;
      aPtl[2].x = 2*Radius + xTrans;            aPtl[2].y = 2*Radius + yTrans;

      arcp.lQ = arcp.lP = Radius;
    } break;

   case WM_PAINT:
    { RECTL rcl;
      SHORT i;

      hps = WinBeginPaint( hwnd, NULLHANDLE, &rcl );
      WinFillRect( hps, &rcl, CLR_BLACK );

      GpiCreateLogColorTable( hps, 0, LCOLF_RGB, 0, 0, NULL );
      GpiSetArcParams( hps, &arcp );

      GpiSetMix( hps, FM_OR );

      for ( i=0; i<3; i++ ) {
         GpiMove( hps, &aPtl[i] ) ;
         GpiSetColor( hps, aColors[i] );
         GpiFullArc( hps, DRO_FILL, MAKEFIXED(1,0) );
      } /* endfor */

      WinEndPaint(hps);
    } break;

   default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
   }
   return FALSE;
} /* end of ClientWndProc */


MRESULT EXPENTRY MyDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   switch(msg) {

      case WM_INITDLG:
         WinSendDlgItemMsg( hwnd, ID_RED_SPIN, SPBM_SETLIMITS,
                            MPFROMLONG(255), MPFROMLONG(0));
         WinSendDlgItemMsg( hwnd, ID_GREEN_SPIN, SPBM_SETLIMITS,
                            MPFROMLONG(255), MPFROMLONG(0));
         WinSendDlgItemMsg( hwnd, ID_BLUE_SPIN, SPBM_SETLIMITS,
                            MPFROMLONG(255), MPFROMLONG(0));
         WinSendDlgItemMsg( hwnd, ID_RED_SPIN, SPBM_SETCURRENTVALUE,
                            MPFROMLONG(255), MPFROMLONG(0));
         WinSendDlgItemMsg( hwnd, ID_GREEN_SPIN, SPBM_SETCURRENTVALUE,
                            MPFROMLONG(255), MPFROMLONG(0));
         WinSendDlgItemMsg( hwnd, ID_BLUE_SPIN, SPBM_SETCURRENTVALUE,
                            MPFROMLONG(255), MPFROMLONG(0));
         break;

     case WM_COMMAND:
        switch (SHORT1FROMMP(mp1)) {

           case ID_TEST:
            { ULONG ulRed, ulGreen, ulBlue;

              WinSendDlgItemMsg( hwnd, ID_RED_SPIN, SPBM_QUERYVALUE,
                                 MPFROMP(&ulRed),
                                 MPFROM2SHORT(0, SPBQ_ALWAYSUPDATE));
              WinSendDlgItemMsg( hwnd, ID_GREEN_SPIN, SPBM_QUERYVALUE,
                                 MPFROMP(&ulGreen),
                                 MPFROM2SHORT(0, SPBQ_ALWAYSUPDATE));
              WinSendDlgItemMsg( hwnd, ID_BLUE_SPIN, SPBM_QUERYVALUE,
                                 MPFROMP(&ulBlue),
                                 MPFROM2SHORT(0, SPBQ_ALWAYSUPDATE));
              aColors[0] = (ulRed   << 16);
              aColors[1] = (ulGreen << 8);
              aColors[2] = (ulBlue);
              WinInvalidateRect( hwndClient, NULL, FALSE );
            } break;

           default:
              return (MRESULT)FALSE;
        }
        break;

     default:
       return(WinDefDlgProc(hwnd, msg, mp1, mp2));
   }

   return FALSE;
} /* end of MyDlgProc */
