#define INCL_WIN
#define INCL_GPI
#include <os2.h>
#include "create24.h"


/* prototypes */
INT main( VOID );
MRESULT EXPENTRY ClientWndProc( HWND, ULONG, MPARAM, MPARAM );


/* globals */
HAB  hab;
RGB  aRGB[] = { /* bitmap data for a 3 row by 8 column bitmap */
     /* 3rd row (bottom)      */
     /*  bBlue  BGreen  bRed  */
       { 0xFF,      0,     0 },
       {    0,      0,  0xFF },
       {    0,   0xFF,     0 },
       { 0xFF,      0,     0 },
       {    0,      0,  0xFF },
       {    0,   0xFF,     0 },
       { 0xFF,      0,     0 },
       {    0,      0,  0xFF },
     /* 2nd row (middle)      */
     /*  bBlue  BGreen  bRed  */
       {    0,   0xFF,     0 },
       { 0xFF,      0,     0 },
       {    0,      0,  0xFF },
       {    0,   0xFF,     0 },
       { 0xFF,      0,     0 },
       {    0,      0,  0xFF },
       {    0,   0xFF,     0 },
       { 0xFF,      0,     0 },
     /* 1st row (top)         */
     /*  bBlue  BGreen  bRed  */
       {    0,      0,  0xFF },
       {    0,   0xFF,     0 },
       { 0xFF,      0,     0 },
       {    0,      0,  0xFF },
       {    0,   0xFF,     0 },
       { 0xFF,      0,     0 },
       {    0,      0,  0xFF },
       {    0,   0xFF,     0 },
     };


INT main (VOID)
{
   HMQ   hmq;
   HWND  hwndFrame;
   HWND  hwndClient;
   CHAR  szClientClass[] = "Client Window";
   QMSG  qmsg;
   ULONG flCreateFlags = FCF_TITLEBAR      /* create: title bar control     */
                       | FCF_SYSMENU       /*         system menu control   */
                       | FCF_MINMAX        /*         min and max buttons   */
                       | FCF_SIZEBORDER    /* draw sizeborders              */
                       | FCF_SHELLPOSITION /* shell decides window position */
                       | FCF_TASKLIST      /* title added to switch list    */
                       | FCF_ICON;         /* frame has an icon             */

   hab = WinInitialize(0);

   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,            /* anchor block handle */
                     szClientClass,  /* class name */
                     ClientWndProc,  /* pointer to window procedure */
                     CS_SIZEREDRAW,  /* class style */
                     0 );            /* number of class data bytes */

   hwndFrame = WinCreateStdWindow(
                HWND_DESKTOP,            /* Desktop window is parent     */
                WS_VISIBLE,              /* window styles                */
                &flCreateFlags,          /* frame control flag           */
                szClientClass,           /* client window class name     */
                "24-Bit Bitmap Example", /* title bar text               */
                0,                       /* no special class style       */
                NULLHANDLE,              /* resource is in .EXE file     */
                ID_FRAME_RES,            /* frame window identifier      */
                &hwndClient              /* client window handle         */
                );

   if ( hwndFrame )
      while (WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndFrame );   /* clean up */
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY ClientWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  static HBITMAP hbm;               /* bit map handle             */
  static SHORT cxClient, cyClient;  /* size of the client window  */

  switch (msg) {
   case WM_CREATE:
    { BITMAPINFOHEADER2 bmih;
      BITMAPINFO2 bmi;
      HPS         hps;

      /* set all values in bmih and bmi structures to zero */
      memset(&bmih, 0, sizeof(BITMAPINFOHEADER2));
      memset(&bmi, 0, sizeof(BITMAPINFO2));

      bmih.cbFix = sizeof(BITMAPINFOHEADER2);
      bmi.cbFix = sizeof(BITMAPINFOHEADER2);

      bmi.cx = bmih.cx = 8;
      bmi.cy = bmih.cy = 3;
      bmi.cPlanes = bmih.cPlanes = 1;
      bmi.cBitCount = bmih.cBitCount = 24;

      /* length of the bitmap storage data in bytes */
      bmi.cbImage = bmih.cbImage = 8*3*4;

      /* X resolution of target device */
      bmi.cxResolution = bmih.cxResolution = (LONG)cxClient;

      /* Y resolution of target device */
      bmi.cyResolution = bmih.cyResolution = (LONG)cyClient;

      /* color encoding */
      bmi.ulColorEncoding = bmih.ulColorEncoding = BCE_RGB;

      hps = WinGetPS (hwnd) ;

      hbm = GpiCreateBitmap (
               hps,
               (PBITMAPINFOHEADER2)&bmih,  /* bitmap header */
               CBM_INIT,
               (PBYTE)aRGB,
               (PBITMAPINFO2)&bmi) ;  /* bitmap header plus color table */

      if (!hbm)
      {  ERRORID err;
         CHAR szBuffer[50];

         err = WinGetLastError(hab);
         sprintf(szBuffer, "GpiCreateBitmap %lx error", err);
         WinMessageBox( HWND_DESKTOP,            /* parent window handle */
                        hwnd,                    /* owner window handle  */
                        szBuffer,                /* MsgBox Text          */
                        "RGB Bitmap Example",    /* MsgBox Title Text    */
                        0,                       /* MsgBox Window ID     */
                        MB_ENTER | MB_WARNING);  /* MsgBox window style  */
         return (MRESULT)TRUE;
      }

      WinReleasePS(hps);
    } break;

   case WM_PAINT:
    { HPS    hps;
      RECTL  rcl;

      hps = WinBeginPaint( hwnd, 0L, &rcl );

      rcl.xLeft = 0;
      rcl.xRight = (LONG)cxClient;
      rcl.yBottom = 0;
      rcl.yTop = (LONG)cyClient;

      WinDrawBitmap( hps,
                     hbm,
                     NULL,            /* PRECTL (NULL = draw whole bitmap) */
                     (PPOINTL)&rcl,   /* bitmap destination                */
                     0L,              /* foreground color                  */
                     0L,              /* background color                  */
                     DBM_STRETCH      /* stretch bmap to coordinates in pt */
                   ) ;

      WinEndPaint( hps );
    }  break;

   case WM_SIZE:
      cxClient = SHORT1FROMMP(mp2);
      cyClient = SHORT2FROMMP(mp2);
      break;

   default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
   }

   return (MRESULT)FALSE;
} /* end of ClientWndProc */

