#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include "framewnd.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY NewFrameProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY MyClientWndProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
PFNWP OldFrameProc;


INT main (VOID)
{
   HAB   hab;
   HMQ   hmq;
   QMSG  qmsg;
   HWND  hwndFrame, hwndClient;
   ULONG flCreateFlags = FCF_TITLEBAR      /* create: title bar control     */
                       | FCF_SYSMENU       /*         system menu control   */
                       | FCF_MENU          /*         action bar            */
                       | FCF_MINMAX        /*         min and max buttons   */
                       | FCF_SIZEBORDER    /* draw sizeborders              */
                       | FCF_SHELLPOSITION /* shell decides window position */
                       | FCF_TASKLIST      /* title added to switch list    */
                       | FCF_ICON;         /* frame has an icon             */
   CHAR szClientClass[] = "Client Window";

   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,
                     szClientClass,
                     MyClientWndProc,
                     CS_SIZEREDRAW,
                     0 );

   hwndFrame = WinCreateStdWindow(
                  HWND_DESKTOP,   /* parent */
                  0,              /* frame window style */
                  &flCreateFlags, /* creation flags for frame window */
                  szClientClass,  /* client window class name */
                  "Subclassed Frame Window",  /* text added to title */
                  0,              /* client window style */
                  NULLHANDLE,     /* resource ID's are in rc file */
                  ID_FRAMEWND,    /* ID for frame window */
                  &hwndClient );  /* address to place client window handle */

   OldFrameProc = WinSubclassWindow( hwndFrame, NewFrameProc );

   WinShowWindow( hwndFrame, TRUE );

   if ( hwndFrame )
      while (WinGetMsg(hab,&qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg(hab, &qmsg);

   WinDestroyWindow( hwndFrame );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end main */


MRESULT EXPENTRY NewFrameProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch (msg) {
   case WM_FORMATFRAME:
    { USHORT i, rc;
      PSWP pswp;
      SWP swpFrame;

      /* have the old frame procedure format the frame's windows */
      rc = (USHORT)OldFrameProc( hwnd, msg, mp1, mp2 );

      /* query the frame size to get the frame height swpFrame.cy */
      WinQueryWindowPos( hwnd, &swpFrame );

      /*
       * go through the frame's windows, and change the way the
       *    old frame procedure formated the windows
       */
      for ( i=0, pswp=(PSWP)mp1; i < rc; i++, pswp++ )
         pswp->y =  swpFrame.cy - (pswp->y + pswp->cy);

      /* return the number of frame controls */
      return (MRESULT)rc;
    } break;
   default:
      return (MRESULT)(*OldFrameProc)(hwnd, msg, mp1, mp2);
   } /* endswitch */
   return FALSE;
} /* NewFrameProc */


MRESULT EXPENTRY MyClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch (msg) {

   // place message handling for client window here

   case WM_COMMAND:
      if ( SHORT1FROMMP(mp2) == CMDSRC_MENU )
         WinAlarm( HWND_DESKTOP, WA_NOTE );
      break;
   case WM_ERASEBACKGROUND:
      return (MRESULT)TRUE;
   default:
      return( WinDefWindowProc( hwnd, msg, mp1, mp2 ));
   } /* endswitch */

   return FALSE;
} /* MyClientWndProc */

