#define INCL_DOSRESOURCES
#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>
#include "frmmenu.h"


/* function protypes */
INT main( VOID );
MRESULT EXPENTRY MyClientWndProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY MyFrameWndProc( HWND, ULONG, MPARAM, MPARAM );

/* global variables */
CLASSINFO fci;
CHAR szMyFrameClass[]  = "My Frame Window";
CHAR szMyClientClass[] = "My Client Window";


INT main( VOID )
{
   HAB  hab;
   HMQ  hmq;
   QMSG qmsg;
   HWND hwndFrame;
   HWND hwndClient;
   SWP  swp;
   FRAMECDATA fcd;

   fcd.cb = sizeof(FRAMECDATA);  /* length of structure */
   fcd.flCreateFlags =  FCF_TITLEBAR      /* create: title bar control     */
                      | FCF_SYSMENU       /*         system menu control   */
                      | FCF_MENU          /*         action bar control    */
                      | FCF_SIZEBORDER    /*         sizeborders           */
                      | FCF_MINMAX        /*         min and max buttons   */
                      | FCF_SHELLPOSITION /* shell decides window position */
                      | FCF_TASKLIST      /* title added to switch list    */
                      | FCF_ICON;         /* frame has an icon             */
   fcd.hmodResources = NULLHANDLE;  /* no DLLs used for resources  */
   fcd.idResources   = ID_FRMMENU;  /* ID number for frame resources */

   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   WinQueryClassInfo( hab, WC_FRAME, &fci );

   WinRegisterClass( hab,                /* anchor block handle */
                     szMyFrameClass,     /* class name */
                     MyFrameWndProc,     /* pointer to window procedure */
                     CS_FRAME            /* class style */
                     | CS_HITTEST
                     | CS_SYNCPAINT
                     | CS_CLIPSIBLINGS,
                     fci.cbWindowData ); /* number of class data bytes */

   WinRegisterClass( hab,              /* anchor block handle */
                     szMyClientClass,  /* class name */
                     MyClientWndProc,  /* pointer to window procedure */
                     CS_SIZEREDRAW,    /* class style */
                     0 );              /* no class data bytes needed */

   hwndFrame  = WinCreateWindow(
                   HWND_DESKTOP,    /* parent window is the desktop */
                   szMyFrameClass,  /* use public frame class */
                   "Adding Frame Controls", /* text added to title bar */
                   0,               /* window style */
                   0, 0, 0, 0,      /* ignored, FCF_SHELLPOSITION was set */
                   NULLHANDLE,      /* no owner window */
                   HWND_TOP,        /* place on top of Desktop's children */
                   ID_FRMMENU,      /* window ID of the frame    */
                   &fcd,            /* data unique to frame windows */
                   NULL );          /* no presentation parameters */

   hwndClient = WinCreateWindow(
                   hwndFrame,       /* parent window is the frame */
                   szMyClientClass, /* privately registered client class */
                   NULL,            /* window name not used by client */
                   0,               /* window style */
                   0, 0, 0, 0,      /* ignored, client window */
                   hwndFrame,       /* owner window is the frame */
                   HWND_BOTTOM,     /* standard Z-order of client windows */
                   FID_CLIENT,      /* ID number recognized by the frame */
                   NULL,            /* no control data */
                   NULL );          /* no presentation parameters */

   WinShowWindow( hwndFrame, TRUE );

   if ( hwndFrame )
      while ( WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndFrame );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end main */


MRESULT MyFrameWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   static HWND     hwndMyMenu;    /* handle to the added frame control */
   static HWND     hwndSysMenu;   /* frame window's system menu */
   static HWND     hwndActionBar; /* frame window's FID_MENU window */
   static HBITMAP  hbmBtn;        /* button bitmap not pressed down */
   static HBITMAP  hbmBtnDep;     /* button bitmap pressed down */
   static SHORT    cxBitmap, cyBitmap;  /* width & height of menu bitmap */

   switch (msg) {
   case WM_CREATE:
    { PVOID pmt; /* pointer to a menu template */
      BITMAPINFOHEADER bmpinfo;

      /* call the frame class window procedure */
      (*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );

      /*  - load the menu template from the exe's resources
       *  - create a menu class window with with ID number MY_FID
       *  - release the resource
       */
      DosGetResource( NULLHANDLE, RT_MENU, MY_FID, &pmt);
      hwndMyMenu = WinCreateWindow( hwnd,
                                    WC_MENU,
                                    NULL,
                                    MS_ACTIONBAR | MS_TITLEBUTTON,
                                    0, 0, 0, 0,
                                    hwnd,
                                    HWND_BOTTOM,
                                    MY_FID,
                                    pmt,
                                    NULL );
      DosFreeResource( pmt );

      /* load the bitmaps of a button both pressed and not pressed */
      hbmBtn    = WinGetSysBitmap( HWND_DESKTOP, SBMP_CHILDSYSMENU );
      hbmBtnDep = WinGetSysBitmap( HWND_DESKTOP, SBMP_CHILDSYSMENUDEP );

      /* get the height and width of the child menu bitmap */
      GpiQueryBitmapParameters( hbmBtn, &bmpinfo );
      cxBitmap = bmpinfo.cx;
      cyBitmap = bmpinfo.cy;

      /* get the following handles for the WM_NEXTMENU message */
      hwndSysMenu   = WinWindowFromID( hwnd, FID_SYSMENU );
      hwndActionBar = WinWindowFromID( hwnd, FID_MENU );
    } break;

   case WM_MEASUREITEM:
      if (((POWNERITEM)mp2)->idItem == MY_MENUBUTTON) {
         ((POWNERITEM)mp2)->rclItem.xRight = cxBitmap;
         ((POWNERITEM)mp2)->rclItem.yTop   = cyBitmap;
         return (MRESULT)cyBitmap;
      } else
         return (MRESULT)(*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );

   case WM_DRAWITEM:
    { POINTL ptl;

      if (((POWNERITEM)mp2)->idItem == MY_MENUBUTTON) {
         ptl.x=((POWNERITEM)mp2)->rclItem.xLeft;
         ptl.y=((POWNERITEM)mp2)->rclItem.yBottom;
         WinDrawBitmap( ((POWNERITEM)mp2)->hps,
            ( (((POWNERITEM)mp2)->fsAttribute && MIA_HILITED)
               ? hbmBtnDep
               : hbmBtn ),
            NULL, &ptl,
            0,0, DBM_NORMAL | DBM_IMAGEATTRS );
         ((POWNERITEM)mp2)->fsAttribute = ((POWNERITEM)mp2)->fsAttributeOld
            &= ~(MIA_CHECKED | MIA_HILITED | MIA_FRAMED );
         return (MRESULT)TRUE;
      } else
         return (MRESULT)(*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );
    } break;

   case WM_NEXTMENU:
      if ( (BOOL)mp2 ) {                 /* if begining of menu */
         if ( (HWND)mp1 == hwndMyMenu )    /* if menu is the menu button   */
            return (MRESULT)hwndSysMenu;   /*    goto system menu next     */
         if ( (HWND)mp1 == hwndActionBar ) /* if menu is the action bar    */
            return (MRESULT)hwndMyMenu;    /*    goto menu button next     */
      } else {                           /* else end of menu */
         if ( (HWND)mp1 == hwndMyMenu )    /* if menu is the menu button   */
            return (MRESULT)hwndActionBar; /*    goto action bar next      */
         if ( (HWND)mp1 == hwndSysMenu )   /* if menu is the system menu   */
            return (MRESULT)hwndMyMenu;    /*    goto menu button next     */
      } /* endif */
      /* let the original frame procedure handle the other cases */
      return (MRESULT)(*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );

   case WM_QUERYFRAMECTLCOUNT:
      /* return the number of controls plus 1 for the added menu button */
      return (MRESULT)((LONG)(*fci.pfnWindowProc)(hwnd, msg, mp1, mp2) + 1);

   case WM_FORMATFRAME:
    { PSWP  aswp;  /* pointer to SWP structures describing frame controls */
      SWP   swp;   /* temporary storage for FID_CLIENT's SWP structure    */
      PSWP  pswpTitleBar;   /* pointer to FID_TITLEBAR's SWP structure    */
      LONG  cxMenu, cyMenu; /* width and height of the added menu button  */
      LONG  xMenu, yMenu;   /* position of menu button                    */
      LONG  NumberOfSWPs;   /* number of controls formatted so far        */
      LONG  i;              /* index through aswp                         */

      NumberOfSWPs = (LONG)(*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );
      aswp = mp1;

      /* (NumberOfSWPs - 1) should be the index to SWP of FID_CLIENT */
      NumberOfSWPs--; /* make NumberOfSWPs index to FID_CLIENT */

      /* copy FID_CLIENT's SWP structure */
      swp = aswp[NumberOfSWPs];

      /* go through the array to find the desired frame controls */
      for ( i=0; i < NumberOfSWPs; i++ )
         if ( WinQueryWindowUShort( aswp[i].hwnd, QWS_ID ) == FID_TITLEBAR ) {
            pswpTitleBar = &aswp[i];
            break;
         }

      cxMenu = cxBitmap;
      cyMenu = pswpTitleBar->cy;
      xMenu  = pswpTitleBar->x;
      yMenu  = pswpTitleBar->y;
      pswpTitleBar->cx -= cxMenu;
      pswpTitleBar->x  += cxMenu;

      /* position menu button where the left side of the title bar used to be
       *    and set the width and height of the menu button
       */
      aswp[ NumberOfSWPs ].fl =  SWP_MOVE
                               | SWP_SIZE
                               | SWP_SHOW;
      aswp[NumberOfSWPs].cx = cxMenu;
      aswp[NumberOfSWPs].cy = cyMenu;
      aswp[NumberOfSWPs].x  = xMenu;
      aswp[NumberOfSWPs].y  = yMenu;
      aswp[NumberOfSWPs].hwnd = hwndMyMenu;
      aswp[NumberOfSWPs].hwndInsertBehind = NULLHANDLE;
      aswp[NumberOfSWPs].ulReserved1 = 0;
      aswp[NumberOfSWPs].ulReserved2 = 0;

      /* done filling MY_FID's SWP structure, increment NumberOfSWPs to */
      /*    point to the next SWP structure                             */
      NumberOfSWPs++;

      /* place FID_CLIENT last by copying it from swp to the end of aswp */
      aswp[NumberOfSWPs] = swp;

      /* account for new menu button being added to aswp */
      NumberOfSWPs++;

      /* return the number of frame controls formatted */
      return (MRESULT)NumberOfSWPs;
    } break;

   case WM_DESTROY:
      /* release the two system bitmaps used for the menu button */
      GpiDeleteBitmap( hbmBtn );
      GpiDeleteBitmap( hbmBtnDep );

      /* call the original frame procedure */
      return (MRESULT)(*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );

   default:
      return (*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );
   } /* endswitch */
   return FALSE;
} /* MyFrameWndProc */


MRESULT EXPENTRY MyClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch (msg) {

   // place message handling for client window here

   case WM_COMMAND:
      if ( SHORT1FROMMP(mp2) == CMDSRC_MENU )
         WinAlarm( HWND_DESKTOP, WA_NOTE );
      break;
   case WM_ERASEBACKGROUND:
      return (MRESULT)TRUE;
   default:
      return( WinDefWindowProc( hwnd, msg, mp1, mp2 ));
   } /* endswitch */
   return FALSE;
} /* MyClientWndProc */

