#define INCL_WIN
#define INCL_GPI
#include <os2.h>
#include "geoshape.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY PgWindowProc( HWND, ULONG, MPARAM, MPARAM );
ULONG SetupPage ( USHORT );
MRESULT EXPENTRY MyNBProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
PFNWP   RealNBProc;
HWND    hwndNotebook;
HWND    hwndPage;


MYPAGEINFO aPageInfo[NUM_PAGES] = {
    0,  BKA_MAJOR, "",       NULLHANDLE, ID_CIRCLE,   CLR_BLUE,
    0,  BKA_MINOR, "Red",    NULLHANDLE, ID_CIRCLE,   CLR_RED,
    0,  BKA_MINOR, "Cyan",   NULLHANDLE, ID_CIRCLE,   CLR_CYAN,
    0,  BKA_MAJOR, "",       NULLHANDLE, ID_SQUARE,   CLR_PINK,
    0,  BKA_MINOR, "Brown",  NULLHANDLE, ID_SQUARE,   CLR_BROWN,
    0,  BKA_MINOR, "Gray",   NULLHANDLE, ID_SQUARE,   CLR_PALEGRAY,
    0,  BKA_MAJOR, "",       NULLHANDLE, ID_TRIANGLE, CLR_GREEN,
    0,  BKA_MINOR, "Yellow", NULLHANDLE, ID_TRIANGLE, CLR_YELLOW,
    0,  BKA_MINOR, "Black",  NULLHANDLE, ID_TRIANGLE, CLR_BLACK
};


INT main(VOID)
{
   HAB  hab;                             /* anchor block handle           */
   HMQ  hmq;                             /* message queue handle          */
   HWND hwndFrame;                       /* frame window handle           */
   HWND hwndClient;                      /* client area window handle     */
   CHAR szPageWindow[] = "PageWindow";
   QMSG qmsg;                            /* message from message queue    */
   HPS  hps;                             /* presentation Space handle     */
   POINTL ptl;
   USHORT usTabX, usTabY;
   USHORT i;

   FRAMECDATA fcd;
   fcd.cb = sizeof(FRAMECDATA);           /* length of structure           */
   fcd.flCreateFlags =  FCF_TITLEBAR      /* create: title bar control     */
                      | FCF_SYSMENU       /*         system menu control   */
                      | FCF_MINMAX        /*         min and max buttons   */
                      | FCF_SIZEBORDER    /* draw sizeborders              */
                      | FCF_SHELLPOSITION /* shell decides window position */
                      | FCF_TASKLIST      /* title added to switch list    */
                      | FCF_ICON;         /* frame has an icon             */

   fcd.hmodResources = NULLHANDLE;        /* handle to a module           */
   fcd.idResources   = ID_FRAMEWND;       /* identifier for the frame     */

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,                   /* anchor block handle        */
                    (PSZ)szPageWindow,      /* window class name          */
                    (PFNWP)PgWindowProc,    /* address of window procedure*/
                    CS_SIZEREDRAW,          /* class style                */
                    0 );                    /* no extra window words      */

   hwndFrame  = WinCreateWindow(
                   HWND_DESKTOP,                 /* parent window handle  */
                   WC_FRAME,                     /* Window class          */
                   "Notebook example",           /* title text            */
                   0,                            /* style                 */
                   0, 0, 0, 0,      /* ignored, FCF_SHELLPOSITION was set */
                   NULLHANDLE,                   /* owner                 */
                   HWND_TOP,                     /* z-order               */
                   ID_FRAMEWND,                  /* id                    */
                   &fcd,                         /* control data          */
                   NULL );                       /* presentation parms    */


   hwndNotebook = WinCreateWindow(
                     hwndFrame,                /* parent window handle    */
                     WC_NOTEBOOK,              /* window class            */
                     (PSZ)NULL,                /* title text              */
                     BKS_SPIRALBIND,           /* style                   */
                     0, 0, 0, 0,               /* ignored, frame will pos */
                     hwndFrame,                /* owner                   */
                     HWND_BOTTOM,              /* z-order                 */
                     FID_CLIENT,               /* id                      */
                     NULL,                     /* control data            */
                     NULL );                   /* presentation parms      */

   RealNBProc = WinSubclassWindow( hwndNotebook, (PFNWP)MyNBProc );

   hwndPage = WinCreateWindow(
                    hwndFrame,                 /* parent window handle    */
                    (PSZ)szPageWindow,         /* window class            */
                    (PSZ)NULL,                 /* title text              */
                    0,                         /* style                   */
                    0, 0, 0, 0,                /* ignored, nbook will pos */
                    hwndFrame,                 /* owner                   */
                    HWND_BOTTOM,               /* z-order                 */
                    ID_BOOKPAGE,               /* id                      */
                    NULL,                      /* control data            */
                    NULL );                    /* presentation parms      */

   hps = WinGetPS( hwndNotebook );

   aPageInfo[0].hbm = GpiLoadBitmap(
                         hps,
                         NULLHANDLE,   /* use the current EXE file */
                         ID_CIRCLE,
                         0L, 0L );     /* no X/Y streching */

   aPageInfo[3].hbm = GpiLoadBitmap(
                         hps,
                         NULLHANDLE,   /* use the current EXE file */
                         ID_SQUARE,
                         0L, 0L );     /* no X/Y streching */

   aPageInfo[6].hbm = GpiLoadBitmap(
                         hps,
                         NULLHANDLE,   /* use the current EXE file */
                         ID_TRIANGLE,
                         0L, 0L );     /* no X/Y streching */

   WinReleasePS(hps);

   for (i = 0; i < NUM_PAGES; i++)
      aPageInfo[i].ulPageID = SetupPage(i);

   ptl.x = 4;  /* average width of a character in dialog coordinates */
   ptl.y = 8;  /* average height of a character in dialog coordinates */

   WinMapDlgPoints( hwndNotebook,         /* get pels per character       */
                    &ptl,
                    1,                    /* # of coordinate points       */
                    TRUE );               /* dialog to window             */

   usTabX = usTabY = ptl.x * 7;

   WinSendMsg( hwndNotebook,
               BKM_SETDIMENSIONS,
               MPFROM2SHORT( usTabX, usTabY ),  /* width and height pels  */
               MPFROMSHORT( BKA_MAJORTAB ) );   /* all major tabs         */

   usTabX = ptl.x * 10;                   /* 10 characters wide           */
   usTabY = (ptl.y * 2) - (ptl.y / 2);    /* 1.5 characters high          */

   WinSendMsg( hwndNotebook,
               BKM_SETDIMENSIONS,
               MPFROM2SHORT (usTabX, usTabY ),  /* width and height pels  */
               MPFROMSHORT( BKA_MINORTAB ) );   /* all minor tabs         */

   WinShowWindow( hwndFrame, TRUE );

   if ( hwndFrame )
      while( WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ) )
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndFrame );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */

ULONG SetupPage ( USHORT cPage )
{
   ULONG   ulNewPageID;
   USHORT  usPageStyle;
   CHAR    szStatusLineText[15];

   usPageStyle = aPageInfo[cPage].usTabAttr
                 | BKA_AUTOPAGESIZE
                 | BKA_STATUSTEXTON;

   ulNewPageID = LONGFROMMR( WinSendMsg(
                                hwndNotebook,
                                BKM_INSERTPAGE,
                                (MPARAM)0,
                                MPFROM2SHORT( usPageStyle, BKA_LAST ) ) );

   if (aPageInfo[cPage].hbm == NULLHANDLE)
      WinSendMsg( hwndNotebook,
                  BKM_SETTABTEXT,
                  MPFROMLONG( ulNewPageID ),
                  MPFROMP( aPageInfo[cPage].pszTabText ) );

   else                                    /* if not text then bitmap tab */
      WinSendMsg( hwndNotebook,
                  BKM_SETTABBITMAP,
                  MPFROMLONG( ulNewPageID ),
                  MPFROMLONG( (LONG)aPageInfo[cPage].hbm ) );

   sprintf( szStatusLineText, "Page %d of 9", (cPage + 1) );
   WinSendMsg( hwndNotebook,
               BKM_SETSTATUSLINETEXT,
               MPFROMLONG(ulNewPageID ),
               MPFROMP( szStatusLineText ) );

   WinSendMsg( hwndNotebook,
               BKM_SETPAGEWINDOWHWND,
               MPFROMLONG( ulNewPageID ),
               MPFROMHWND( hwndPage ) );

   return (ulNewPageID);
} /* end of SetupPage */


MRESULT EXPENTRY PgWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   static SHORT sPageX, sPageY;      /* page window X and Y dimensions   */
   static ARCPARAMS arcp = { 1, 1, 0, 0 };


   switch( msg ) {
      case WM_PAINT:
       { HPS     hps;
         RECTL   rcl;
         POINTL  ptl;
         ULONG   ulCurPgID;
         PMYPAGEINFO pMyPageInfo;

         hps = WinBeginPaint( hwnd, NULLHANDLE, &rcl );

         ulCurPgID = (ULONG)WinSendMsg(
                        hwndNotebook,
                        BKM_QUERYPAGEID,
                        (MPARAM)0,                     /* reference page */
                        MPFROM2SHORT( BKA_TOP, 0 ) );  /* order, style   */

         pMyPageInfo = (PMYPAGEINFO)aPageInfo;

         while (pMyPageInfo->ulPageID != ulCurPgID)
            ++pMyPageInfo;

         if (pMyPageInfo->ulShape == ID_CIRCLE) {
            SHORT x, y, Radius;

            x = sPageX / 3;
            y = sPageY / 3;
            Radius = ( x > y ? y : x );
            arcp.lQ = arcp.lP = Radius;
            GpiSetArcParams( hps, &arcp );

            ptl.x = sPageX / 2;
            ptl.y = sPageY / 2;
            GpiMove( hps, &ptl );

            GpiSetColor( hps, pMyPageInfo->lColor );

            GpiFullArc( hps, DRO_FILL, MAKEFIXED(1,0) );
         }
         else if (pMyPageInfo->ulShape == ID_SQUARE) {
            SHORT w;

            if (sPageX > sPageY)
               w = sPageY / 2;
            else
               w = sPageX / 2;

            rcl.xLeft = (sPageX / 2) - (w / 2);
            rcl.xRight = rcl.xLeft + w;
            rcl.yBottom = (sPageY / 2 ) - (w / 2);
            rcl.yTop = rcl.yBottom + w;

            WinFillRect( hps,
                         &rcl,
                         pMyPageInfo->lColor );
         }
         else if (pMyPageInfo->ulShape == ID_TRIANGLE) {

            GpiSetColor( hps, pMyPageInfo->lColor );
            GpiBeginArea( hps, BA_NOBOUNDARY );
            ptl.x = sPageX / 4;
            ptl.y = sPageY / 4;
            GpiMove( hps, &ptl );

            ptl.x *= 3;
            GpiLine( hps, &ptl );

            ptl.x = sPageX / 2;
            ptl.y *= 3;
            GpiLine( hps, &ptl );

            ptl.x /= 2;
            ptl.y /= 3;
            GpiLine( hps, &ptl );
            GpiEndArea( hps );
         }

         WinEndPaint( hps );
       } break;

      case WM_SIZE:
         sPageX = SHORT1FROMMP( mp2 );
         sPageY = SHORT2FROMMP( mp2 );
         break;

      case WM_ERASEBACKGROUND:
         return (MRESULT)TRUE;

      default:
         return WinDefWindowProc( hwnd, msg, mp1, mp2 );
   }
   return (MRESULT)FALSE;
} /* end of PgWindowProc */


MRESULT EXPENTRY MyNBProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   if (msg == WM_CLOSE) {
      WinPostMsg( hwnd, WM_QUIT, (MPARAM)0,(MPARAM)0 );
      RealNBProc( hwnd, msg, mp1, mp2 );
   }
   else
      return RealNBProc( hwnd, msg, mp1, mp2 );
} /* end of MyNBProc */
