#define INCL_WIN
#define INCL_DOS
#include <os2.h>
#include "hooks.h"


/* global variables */
HAB hab2;
HMODULE hMod;
PFN pInputHook, pRecordHook, pPlaybackHook;
QMSG aQmsg1[MAX_Q_ENTRIES], aQmsg2[MAX_Q_ENTRIES];
USHORT cQ1, cQ2, usInQ, usOutQ;
USHORT cOut = 0;


VOID EXPENTRY MyInit( HAB hab )
{

   hab2 = hab;

   DosLoadModule( NULL, 0, "HOOKS", &hMod);

   DosQueryProcAddr( hMod,
                     0,                    /* ordinal number not used     */
                     "InputHook",          /* procedure name              */
                     &pInputHook);         /* pointer to hook proc        */

   DosQueryProcAddr( hMod,
                     0,                    /* ordinal number not used     */
                     "JournalRecordHook",  /* procedure name              */
                     &pRecordHook);        /* pointer to hook proc        */

   DosQueryProcAddr( hMod,
                     0,                      /* ordinal number not used   */
                     "JournalPlaybackHook",  /* procedure name            */
                     &pPlaybackHook);        /* pointer to hook proc      */

} /* end of MyInit */


VOID EXPENTRY SetInputHook( VOID )
{
   WinSetHook( hab2,
               NULLHANDLE,                /* hook system msg Q            */
               HK_INPUT,                  /* hook type                    */
               pInputHook,                /* our hook handler             */
               hMod );                    /* DLL needed for system hook   */

} /* end of SetInputHook */


VOID EXPENTRY ReleaseInputHook( VOID )
{
   WinReleaseHook( hab2,
                   NULLHANDLE,            /* hook system msg Q            */
                   HK_INPUT,              /* hook type                    */
                   pInputHook,            /* our hook handler             */
                   hMod );                /* DLL needed for system hook   */

   DosFreeModule(hMod);
} /* end of ReleaseInputHook */


VOID EXPENTRY SetRecordHook( USHORT usQ )
{
   if(usQ == 1) {
      cQ1 = 0;
      usInQ = 1;
   }
   else {
      cQ2 = 0;
      usInQ = 2;
   }

   WinSetHook( hab2,
               NULLHANDLE,                         /* hook system msg Q   */
               HK_JOURNALRECORD,                   /* hook type           */
               pRecordHook,                        /* our hook handler    */
               hMod);                              /* hook proc DLL       */

} /* end of SetRecordHook */


VOID EXPENTRY ReleaseRecordHook( VOID )
{
   WinReleaseHook( hab2,
                   NULLHANDLE,                     /* system msg Q        */
                   HK_JOURNALRECORD,               /* hook type           */
                   pRecordHook,                    /* our hook handler    */
                   hMod);                          /* hook proc DLL       */

} /* end of ReleaseRecordHook */


BOOL EXPENTRY InputHook ( HAB hab, PQMSG pQmsg, ULONG fs )
{

   if( ( pQmsg->msg == WM_CHAR ) &&
       ( CHARMSG(&pQmsg->msg)->fs & KC_CTRL ) &&
       ( CHARMSG(&pQmsg->msg)->fs & KC_KEYUP ) ) {

      if( (CHARMSG(&pQmsg->msg)->scancode == SCAN_1) ||
          (CHARMSG(&pQmsg->msg)->scancode == SCAN_2) ) {
         usOutQ = CHARMSG(&pQmsg->msg)->scancode - 1;
         WinSetHook( hab2,
                     NULLHANDLE,                   /* hook system msg Q   */
                     HK_JOURNALPLAYBACK,           /* hook type           */
                     pPlaybackHook,                /* our hook handler    */
                     hMod);                        /* hook proc DLL       */
      }
   }
   return(FALSE);                       /* pass the message down the chain */

} /* end of InputHook */



VOID EXPENTRY JournalRecordHook( HAB hab, PQMSG pQmsg )
{
   PQMSG pCurQmsg;

   if( pQmsg->msg == WM_CHAR ) {

      if(usInQ == 1) {
         pCurQmsg = (PQMSG)(&aQmsg1[cQ1]);
         if (cQ1 >= MAX_Q_ENTRIES)
            cQ1 = 0;
         else
           ++cQ1;
      }
      else {
         pCurQmsg = (PQMSG)(&aQmsg2[cQ2]);
         if (cQ2 >= MAX_Q_ENTRIES)
            cQ2 = 0;
         else
           ++cQ2;
      }
      memcpy(pCurQmsg, pQmsg, sizeof(QMSG));

   }
} /* end of JournalRecordHook */


ULONG EXPENTRY JournalPlaybackHook( HAB hab, BOOL fSkip, PQMSG pQmsg )
{
   PQMSG pCurQmsg;

   if(fSkip == FALSE) {
      if(usOutQ == 1)
         pCurQmsg = (PQMSG)(&aQmsg1[cOut]);
      else
         pCurQmsg = (PQMSG)(&aQmsg2[cOut]);

      pCurQmsg->time = pQmsg->time;

      memcpy(pQmsg, pCurQmsg, sizeof(QMSG));
   }
   else {
      ++cOut;
      if( ((usOutQ == 1) && (cOut >= cQ1)) ||
          ((usOutQ == 2) && (cOut >= cQ2)) ) {

         WinReleaseHook(hab2,
                        NULLHANDLE,                /* hook system msg Q   */
                        HK_JOURNALPLAYBACK,        /* hook type           */
                        pPlaybackHook,             /* our hook handler    */
                        hMod);                     /* hook proc DLL       */
         cOut = 0;
      }
   }

   return 0L;  /* time in millisecs */

} /* end of JournalPlaybackHook */
