#define INCL_WIN
#define INCL_GPI
#define INCL_DEV
#include <os2.h>
#include "lct.h"


/* prototypes */
INT main( VOID );
MRESULT EXPENTRY ClientWndProc( HWND, ULONG, MPARAM, MPARAM );


INT main (VOID)
{
   HAB   hab;
   HMQ   hmq;
   HWND  hwndFrame;
   HWND  hwndClient;
   CHAR  szClientClass[] = "Client Window";
   QMSG  qmsg;
   ULONG flCreateFlags = FCF_TITLEBAR      /* create: title bar control     */
                       | FCF_SYSMENU       /*         system menu control   */
                       | FCF_MINMAX        /*         min and max buttons   */
                       | FCF_SIZEBORDER    /* draw sizeborders              */
                       | FCF_SHELLPOSITION /* shell decides window position */
                       | FCF_TASKLIST      /* title added to switch list    */
                       | FCF_ICON;         /* frame has an icon             */

   hab = WinInitialize(0);

   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,            /* anchor block handle */
                     szClientClass,  /* class name */
                     ClientWndProc,  /* pointer to window procedure */
                     CS_SIZEREDRAW,  /* class style */
                     0 );            /* number of class data bytes */

   hwndFrame = WinCreateStdWindow(
                HWND_DESKTOP,            /* Desktop window is parent     */
                WS_VISIBLE,              /* window styles                */
                &flCreateFlags,          /* frame control flag           */
                szClientClass,           /* client window class name     */
                "Default Logical Color Table", /* title bar text         */
                0,                       /* no special class style       */
                NULLHANDLE,              /* resource is in .EXE file     */
                ID_FRAME_RES,            /* frame window identifier      */
                &hwndClient              /* client window handle         */
                );

   if ( hwndFrame )
      while (WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndFrame );   /* clean up */
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY ClientWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   static SHORT cxClient, cyClient;      /* size of the client window      */

   switch( msg ) {

   case WM_PAINT:
    { HPS    hps;
      RECTL  rectl;
      ULONG  ulyStart, ulyInc, ulyExtra;
      LONG   i;

      hps = WinBeginPaint( hwnd, 0L, &rectl );

      ulyStart = (LONG)cyClient;                 /* start at the top */
      ulyInc = (LONG)cyClient / NUM_INDICES;     /* row size in pels */
      ulyExtra = (LONG)cyClient % NUM_INDICES;   /* extra pels       */

      for (i = CLR_FALSE; i <= CLR_PALEGRAY; i++) {
         rectl.xLeft = 0;
         rectl.xRight = (LONG)cxClient;
         rectl.yTop = ulyStart;
         rectl.yBottom = ulyStart-ulyInc;

         ulyStart -= ulyInc;         /* reset start for next time around */

            if (ulyExtra) {             /* distribute any remaining rows */
               rectl.yBottom--;
               ulyStart--;
               ulyExtra--;
            }

         WinFillRect(hps, &rectl, i);
      }

      WinEndPaint( hps );
    } break;

   case WM_SIZE:
      cxClient = SHORT1FROMMP(mp2);
      cyClient = SHORT2FROMMP(mp2);
      break;

   case WM_ERASEBACKGROUND:
      /* return TRUE to request PM to paint the window background */
      return (MRESULT)( TRUE );

   default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
   }

   return (MRESULT)FALSE;
} /* end of ClientWndProc */
