#define INCL_WIN
#define INCL_GPI
#include <os2.h>
#include "ownerdr.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY MyFrameProc( HWND, ULONG, MPARAM, MPARAM );
VOID InitCnr( HWND );


/* global variables */
PFNWP OldFrameWndProc;
LONG  alColors[256*2];  /* array holds index and RGB values */
CHAR  aRGBs[256][10];   /* array to hold ascii RGBs         */

INT main( VOID )
{
   HAB  hab;
   HMQ  hmq;
   QMSG qmsg;
   HWND hwndFrame;  /* frame window handle */
   HWND  hwndCnr;   /* container window handle */
   FRAMECDATA fcd;

   fcd.cb = sizeof(FRAMECDATA);           /* length of structure          */
   fcd.flCreateFlags =  FCF_TITLEBAR      /* create: title bar control    */
                      | FCF_SYSMENU       /*         system menu control  */
                      | FCF_SIZEBORDER    /*         sizeborders          */
                      | FCF_MINMAX        /*         min and max buttons  */
                      | FCF_SHELLPOSITION /* shell decides window pos     */
                      | FCF_ICON          /* frame has an icon            */
                      | FCF_TASKLIST;     /* title added to switch list   */

   fcd.hmodResources = NULLHANDLE;        /* Handle to a module           */
   fcd.idResources   = ID_FRAMEWND;       /* identifier for the frame     */

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue( hab, 0 );

   hwndFrame  = WinCreateWindow(
                   HWND_DESKTOP,        /* parent window is the desktop    */
                   WC_FRAME,            /* class name                      */
                   "Container Example", /* text added to title bar         */
                   0,                   /* window style                    */
                   0,0,0,0,             /* ignored, FCF_SHELLPOSITION used */
                   NULLHANDLE,          /* no owner window                 */
                   HWND_TOP,            /* Top of Desktop's children       */
                   ID_FRAMEWND,         /* ID number for frame resources   */
                   &fcd,                /* data unique for frame windows   */
                   NULL );              /* no presentation parameters      */

   /* Now create the container window. */
   hwndCnr = WinCreateWindow(
                hwndFrame,         /* parent window handle   */
                WC_CONTAINER,      /* window class           */
                NULL,              /* no window text         */
                CCS_AUTOPOSITION   /* window style           */
                | CCS_READONLY,
                0, 0, 0, 0,        /* frame formats client   */
                hwndFrame,         /* owner                  */
                HWND_TOP,          /* Z-order                */
                FID_CLIENT,        /* ID                     */
                NULL,              /* no control data        */
                NULL);             /* no presentation parms  */

   InitCnr(hwndCnr);

   OldFrameWndProc = WinSubclassWindow( hwndFrame, MyFrameProc );

   WinShowWindow( hwndFrame, TRUE );

   if ( hwndFrame && hwndCnr )
      while( WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ) )
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY MyFrameProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{

   if ( msg == WM_DRAWITEM )
   {  PCNRDRAWITEMINFO pCnrDrawItemInfo;
      PUSERRECORD  pUserRecord;

      pCnrDrawItemInfo = (PCNRDRAWITEMINFO)((POWNERITEM)mp2)->hItem;
      pUserRecord = (PUSERRECORD)(pCnrDrawItemInfo->pRecord);

      /* NOTE: pUserRecord will be NULL if this message is for    */
      /* the column heading.                                      */
      if ((ULONG)pUserRecord) {

         /* Put the PS into RGB mode */
         GpiCreateLogColorTable ( ((POWNERITEM)mp2)->hps,
                                  LCOL_RESET,
                                  LCOLF_RGB,
                                  0L,
                                  0L,
                                  NULL) ;

         WinFillRect(
            ((POWNERITEM)mp2)->hps,
            &((POWNERITEM)mp2)->rclItem,
            ((PUSERRECORD)(pCnrDrawItemInfo->pRecord))->ur_rgbValue );

         return 0;
      }
   }

   return (MRESULT)(*OldFrameWndProc)( hwnd, msg, mp1, mp2 );
} /* end of MyFrameProc */


VOID InitCnr(HWND hwnd)
{
   CNRINFO  cnrinfo;
   PUSERRECORD     pStartingUserRecord, pUserRecord;
   RECORDINSERT    recordInsert;
   PFIELDINFO      pStartingFieldInfo, pFieldInfo;
   FIELDINFOINSERT fieldInfoInsert;
   PCOLORINFO      pci;
   HPS    hps;
   LONG   lColors;
   ULONG  i;


   hps = WinGetPS(hwnd);

   lColors = GpiQueryRealColors(
                hps,
                LCOLOPT_INDEX,      /* Return index and RGB */
                0L,                 /* Start color index    */
                (LONG)256*2,        /* Max array elements   */
                (PLONG)alColors);   /* Area to fill         */

   WinReleasePS(hps);

   lColors /= 2;

   cnrinfo.cb = sizeof(CNRINFO);
   cnrinfo.pszCnrTitle = "Physical Color Table";
   cnrinfo.cFields = 3;

   cnrinfo.flWindowAttr = CV_DETAIL
                          | CA_CONTAINERTITLE
                          | CA_TITLESEPARATOR
                          | CA_DETAILSVIEWTITLES;

   WinSendMsg( hwnd,
               CM_SETCNRINFO,
               &cnrinfo,
               MPFROMLONG(CMA_FLWINDOWATTR | CMA_CNRTITLE) );

    pUserRecord = WinSendMsg(
                     hwnd,
                     CM_ALLOCRECORD,
                     MPFROMLONG( (LONG)(sizeof(USERRECORD) -
                                        sizeof(RECORDCORE)) ),
                     MPFROMLONG(lColors) );

    /* Save pointer to the first record */
    pStartingUserRecord = pUserRecord;

    pci = (PCOLORINFO)&alColors;

    for(i = 0; i < lColors; i++) {

      pUserRecord->recordCore.cb = sizeof(RECORDCORE);
      pUserRecord->ur_lIndex = pci->ci_lIndex;
      pUserRecord->ur_rgbValue = pci->ci_rgbValue;

      /******************************************************************/
      /* Currently, the container will only display integer values in   */
      /* decimal format.  We use "sprintf" to convert the decimal value */
      /* into an acsii string.  The ascii string will display the RGB   */
      /* in HEX format.                                                 */
      /******************************************************************/
      sprintf(aRGBs[i], "%lx", pci->ci_rgbValue);
      pUserRecord->pszRGB = aRGBs[i];

      pUserRecord = (PUSERRECORD)pUserRecord->recordCore.preccNextRecord;
      ++pci;

    }

    recordInsert.cb = sizeof(RECORDINSERT);
    recordInsert.pRecordParent= NULL;
    recordInsert.pRecordOrder = (PRECORDCORE)CMA_END;
    recordInsert.zOrder = (USHORT)CMA_TOP;
    recordInsert.cRecordsInsert=(USHORT)lColors;
    recordInsert.fInvalidateRecord = TRUE;

    WinSendMsg( hwnd,
                CM_INSERTRECORD,
                (PRECORDCORE)pStartingUserRecord,
                &recordInsert
              );

    pFieldInfo = WinSendMsg( hwnd,
                             CM_ALLOCDETAILFIELDINFO,
                             MPFROMLONG(3),
                             NULL
                           );

    pStartingFieldInfo = pFieldInfo;

    pFieldInfo->cb = sizeof(FIELDINFO);

    pFieldInfo->flData = CFA_HORZSEPARATOR | CFA_CENTER |
                         CFA_SEPARATOR | CFA_ULONG;
    pFieldInfo->flTitle = CFA_CENTER;
    pFieldInfo->pTitleData = "Index";
    pFieldInfo->offStruct = FIELDOFFSET(USERRECORD, ur_lIndex);
    pFieldInfo = pFieldInfo->pNextFieldInfo;

    pFieldInfo->cb = sizeof(FIELDINFO);
    pFieldInfo->flData = CFA_HORZSEPARATOR | CFA_CENTER |
                         CFA_SEPARATOR | CFA_OWNER;
    pFieldInfo->flTitle = CFA_CENTER;
    pFieldInfo->pTitleData = "Color";
    pFieldInfo = pFieldInfo->pNextFieldInfo;

    pFieldInfo->cb = sizeof(FIELDINFO);
    pFieldInfo->flData = CFA_HORZSEPARATOR | CFA_CENTER |
                         CFA_SEPARATOR | CFA_STRING;
    pFieldInfo->flTitle = CFA_CENTER;
    pFieldInfo->pTitleData =  "RGB";
    pFieldInfo->offStruct = FIELDOFFSET(USERRECORD, pszRGB);

    fieldInfoInsert.cb = (ULONG)(sizeof(FIELDINFOINSERT));
    fieldInfoInsert.pFieldInfoOrder = (PFIELDINFO)CMA_FIRST;
    fieldInfoInsert.cFieldInfoInsert = (SHORT)(3);
    fieldInfoInsert.fInvalidateFieldInfo = TRUE;

    WinSendMsg( hwnd,
                CM_INSERTDETAILFIELDINFO,
                MPFROMP(pStartingFieldInfo),
                MPFROMP(&fieldInfoInsert)
              );

} /* end of InitCnr */
