#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>
#include "ownrmenu.h"


#define LAST_BTN 3


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY ClientWndProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY newFrameProc( HWND, ULONG, MPARAM, MPARAM );
VOID SetupForButtons( HAB, HWND );
VOID DrawButton( POWNERITEM );


/* globals */
HAB   hab;
HWND  hwndFrame;
PFNWP oldFrameProc;
SHORT BtnBorderX;
SHORT BtnBorderY;
SHORT BtnHeight;
SHORT BtnWidth;
SHORT BtnMidX;
SHORT BtnMidY;
SHORT BtnTextHeight = 0;
HBITMAP hbmBtnCorner;
struct _BtnList {
   char *BtnLabel;
   HBITMAP Btnhbm;
} BtnList[] = {
   "~Drive",   0,
   "~Folder",  0,
   "F~ile",    0,
   "~Program", 0
}; /* end BtnList */
ULONG BmpList[] = { SBMP_DRIVE,
                    SBMP_FOLDER,
                    SBMP_FILE,
                    SBMP_PROGRAM };


INT main( VOID )
{
   HMQ   hmq;
   QMSG  qmsg;
   HWND  hwndClient;
   static CHAR szClientClass[] = "MyButtonControls";
   ULONG flCreateFlags = FCF_TITLEBAR      /* create: title bar control     */
                       | FCF_SYSMENU       /*         system menu control   */
                       | FCF_MENU          /*         action bar            */
                       | FCF_MINMAX        /*         min and max buttons   */
                       | FCF_SIZEBORDER    /* draw sizeborders              */
                       | FCF_SHELLPOSITION /* shell decides window position */
                       | FCF_TASKLIST      /* title added to switch list    */
                       | FCF_ICON;         /* frame has an icon             */


   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,            /* anchor block handle */
                     szClientClass,  /* class name */
                     ClientWndProc,  /* pointer to window procedure */
                     CS_SIZEREDRAW,  /* class style */
                     0 );            /* number of class data bytes */

   hwndFrame = WinCreateStdWindow(
                 HWND_DESKTOP,   /* parent */
                 WS_VISIBLE,     /* frame window style */
                 &flCreateFlags, /* creation flags for frame window */
                 szClientClass,  /* client window class name */
                 "Owner Menus",  /* text added to title */
                 0,              /* client window style */
                 NULLHANDLE,     /* resource ID's are in rc file */
                 ID_OWNRMENU,     /* ID for frame window */
                 &hwndClient );  /* address to place client window handle */

   oldFrameProc = WinSubclassWindow( hwndFrame, newFrameProc );

   if ( hwndFrame )
      while ( WinGetMsg( hab, &qmsg, NULLHANDLE, 0L, 0L ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndFrame );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end main */


MRESULT EXPENTRY newFrameProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg) {
   case WM_TRANSLATEACCEL:
    { PQMSG   pqmsg;
      USHORT  us, id;

      if ((MRESULT)(*oldFrameProc)(hwnd, msg, mp1, mp2))
         return (MRESULT)TRUE;
      else {

         /* newFrameProc's mp1 parameter is a pointer to a QMSG structure  */
         pqmsg = (PQMSG)mp1;

         /* the QMSG structure has a WM_CHAR mp1 message we want a part of */
         us = (USHORT)pqmsg->mp1;

         /* check if KC_KEYUP is off and KC_ALT is on */
         if ( !(us & KC_KEYUP) && (us & KC_ALT) ) {
            /* check for our owner drawn menu's mnemonics */
            switch ( SHORT1FROMMP( pqmsg->mp2 )) {
            case 'D': case 'd':
               id = ID_DRIVE;
               break;
            case 'F': case 'f':
               id = ID_FOLDER;
               break;
            case 'I': case 'i':
               id = ID_FILE;
               break;
            case 'P': case 'p':
               id = ID_PROGRAM;
               break;
            default:
               return FALSE;
            } /* end switch */
            if ( (SHORT)WinSendMsg( WinWindowFromID( hwnd, FID_MENU ),
                        MM_QUERYSELITEMID,
                        MPFROM2SHORT(  0, FALSE ),
                        MPFROM2SHORT(  0, 0 ) ) != MIT_NONE ) //>= ID_DRIVE )
               return FALSE;

            WinSendMsg( WinWindowFromID( hwnd, FID_MENU ),
                        MM_SELECTITEM,
                        MPFROM2SHORT( id, FALSE ),
                        MPFROM2SHORT(  0, FALSE ) );

            pqmsg->msg  = WM_NULL;
            pqmsg->hwnd = NULLHANDLE;
            pqmsg->mp1  = MPVOID;
            pqmsg->mp2  = MPVOID;

            return (MRESULT)TRUE;
         } /* end if */
      } /* end if */
    } return FALSE;
   default:
      return (MRESULT)(*oldFrameProc)(hwnd, msg, mp1, mp2);
   } /* endswitch */
   return FALSE;
} /* end newFrameProc */


MRESULT EXPENTRY  ClientWndProc(
   HWND hwnd,
   ULONG msg,
   MPARAM mp1,
   MPARAM mp2 )
{
   HWND hwndMenu;
   HPS hps;
   int i;

   switch (msg) {
   case WM_CREATE:
      SetupForButtons( hab, hwnd );
      hwndMenu = WinWindowFromID( hwndFrame, FID_MENU );
      break;
   case WM_MEASUREITEM:
      ((POWNERITEM)mp2)->rclItem.xRight = BtnWidth;
      ((POWNERITEM)mp2)->rclItem.yTop   = BtnHeight;
      return (MRESULT)BtnHeight;
   case WM_DRAWITEM:
      DrawButton( (POWNERITEM)mp2 );
      return (MRESULT)TRUE;
   case WM_COMMAND:
      if ( SHORT1FROMMP(mp2) == CMDSRC_MENU )
         WinAlarm( HWND_DESKTOP, WA_NOTE );
      break;
   case WM_ERASEBACKGROUND:
      return (MRESULT) TRUE;
   case WM_DESTROY:
      GpiDeleteBitmap( hbmBtnCorner );
      for ( i=1; i<=LAST_BTN; i++ )
         GpiDeleteBitmap( BtnList[i].Btnhbm );
      break;
   default:
      return (MRESULT)WinDefWindowProc(hwnd,msg,mp1,mp2);
   } /* endswitch */
   return (MRESULT)FALSE;
} /* end of ClientWndProc */


VOID SetupForButtons( HAB hab, HWND hwnd )
{
   BITMAPINFOHEADER2 bmpinfo2;
   BITMAPINFOHEADER bmpinfo;
   SHORT MaxBmpHeight = 0;
   SHORT MaxBmpWidth  = 0;
   SHORT MaxStrWidth = 0;
   SHORT AveCharWidth;
   FONTMETRICS font;
   HBITMAP hbmOld;
   SIZEL szl;
   POINTL ptl;
   RECTL rctl;
   HDC hdcMem;
   HPS hps;
   int StrLen;
   int i;

   /* get the system font's size */
   hps = WinGetPS( hwnd );
      GpiQueryFontMetrics( hps, (LONG)sizeof(font), &font );
   WinReleasePS( hps );
   BtnTextHeight = font.lMaxBaselineExt;
   AveCharWidth = font.lAveCharWidth;

   /* get the system bitmaps */
   for ( i=0; i<=LAST_BTN; i++ ) {
      BtnList[i].Btnhbm = WinGetSysBitmap( HWND_DESKTOP, BmpList[i] );
      GpiQueryBitmapParameters( BtnList[i].Btnhbm, &bmpinfo );
      if ( bmpinfo.cy > MaxBmpHeight )
         MaxBmpHeight = bmpinfo.cy;
      if ( bmpinfo.cx > MaxBmpWidth )
         MaxBmpWidth = bmpinfo.cx;
      if ( (StrLen=strlen(BtnList[i].BtnLabel)) > MaxStrWidth )
         MaxStrWidth = StrLen - 1; /* subtract one for the tilde character */
   }

   /* Convert MaxStrWidth from the number of characters to the number */
   /*   of pels wide the string needs                                 */
   MaxStrWidth = MaxStrWidth * AveCharWidth;

   /* get the nominal-border widths SV_CXBORDER and SV_CYBORDER       */
   BtnBorderX = WinQuerySysValue( HWND_DESKTOP, SV_CXBORDER );
   BtnBorderY = WinQuerySysValue( HWND_DESKTOP, SV_CYBORDER );

   /* set the buttons height and width */
   BtnHeight = 7*BtnBorderY + MaxBmpHeight + BtnTextHeight;
   BtnWidth  = 6*BtnBorderX + 4*AveCharWidth +
               (MaxBmpWidth>MaxStrWidth ? MaxBmpWidth : MaxStrWidth);

   /* calculate the size of the middle section */
   BtnMidX = BtnWidth  - 2*BtnBorderX;
   BtnMidY = BtnHeight - 2*BtnBorderY;

   /* draw a bitmap for the buttons upper right and lower left corners */
   hdcMem = DevOpenDC( hab,
                       OD_MEMORY,
                       "*",
                       0L,
                       NULL,
                       NULLHANDLE );

   szl.cx = szl.cy = 0;
   hps = GpiCreatePS(  hab
                     , hdcMem
                     , &szl
                     , PU_PELS
                     | GPIF_DEFAULT
                     | GPIT_MICRO
                     | GPIA_ASSOC
                    );

   bmpinfo.cbFix     = 12L;
   bmpinfo.cx        = BtnBorderX;
   bmpinfo.cy        = BtnBorderY;
   bmpinfo.cPlanes   = 1;
   bmpinfo.cBitCount = 1;
   hbmBtnCorner = GpiCreateBitmap( hps,
                                   (PBITMAPINFOHEADER2)&bmpinfo,
                                   0,
                                   NULL,
                                   NULL );

   hbmOld = GpiSetBitmap( hps,
                          hbmBtnCorner );

   /* clear the background */
   GpiErase( hps );

   /* create the diagonal meeting between the light and shaded colors */
   GpiSetColor( hps , CLR_FALSE );
   GpiBeginPath( hps , 1L ); /* since we have a micro-PS, use paths */
   ptl.x = 0;
   ptl.y = 0;
   GpiMove( hps , &ptl ); /* start at the lower left corner */

   ptl.x = BtnBorderX;
   GpiLine( hps, &ptl ); /* go along the bottom to the lower right corner */

   ptl.y = BtnBorderY;
   GpiLine( hps, &ptl ); /* go up to the upper right corner */

   GpiCloseFigure( hps );
   GpiEndPath( hps );
   GpiFillPath( hps, 1, FPATH_ALTERNATE );

   hbmOld = GpiSetBitmap( hps, NULLHANDLE );

   GpiDestroyPS( hps ); /* release handle to memory presentation space */
   DevCloseDC( hdcMem ); /* release handle to memory Device Controller */
} /* end of SetupForButtons */


VOID DrawButton( POWNERITEM pitm )
{
   HPS hps;
   SHORT ButtonID;
   BOOL BtnDown;

   LONG ColorTop = SYSCLR_BUTTONLIGHT;
   LONG ColorBottom = SYSCLR_BUTTONDARK;
   POINTL ptl;
   RECTL rctl;
   SHORT x, y;

   hps = pitm->hps;
   ButtonID = pitm->idItem - ID_BASE;
   BtnDown = pitm->fsAttribute && MIA_HILITED;

   /* location of the lower left corner of the button */
   x = pitm->rclItem.xLeft;
   y = pitm->rclItem.yBottom;

   pitm->fsAttribute = pitm->fsAttributeOld
      &= ~(MIA_CHECKED | MIA_HILITED | MIA_FRAMED );

   if ( BtnDown ) {
      ColorTop = SYSCLR_BUTTONDARK;
      ColorBottom = SYSCLR_BUTTONLIGHT;
   }

   /* draw the left edge */
   rctl.xLeft   = x;
   rctl.yBottom = y+BtnBorderY;
   rctl.xRight  = x+BtnBorderX;
   rctl.yTop    = rctl.yBottom + BtnMidY;
   WinFillRect( hps, &rctl, ColorTop );

   /* draw the right edge */
   rctl.xLeft   = x+BtnBorderX+BtnMidX;
   rctl.xRight  = x+BtnWidth;
   WinFillRect( hps, &rctl, ColorBottom );

   /* draw the top edge */
   rctl.xLeft   = x;
   rctl.yBottom = y+BtnBorderY+BtnMidY;
   rctl.xRight  = x+BtnBorderX+BtnMidX;
   rctl.yTop    = y+BtnHeight;
   WinFillRect( hps, &rctl, ColorTop );

   /* draw the bottom edge */
   rctl.xLeft   = x+BtnBorderX;
   rctl.yBottom = y;
   rctl.xRight  = x+BtnWidth;
   rctl.yTop    = y+BtnBorderY;
   WinFillRect( hps, &rctl, ColorBottom );

   /* draw the middle section */
   rctl.xLeft   = x+BtnBorderX;
   rctl.yBottom = y+BtnBorderY;
   rctl.xRight  = x+BtnBorderX+BtnMidX;
   rctl.yTop    = y+BtnBorderY+BtnMidY;
   WinFillRect( hps, &rctl, SYSCLR_BUTTONMIDDLE );

   /* bitblt in the corners */
   ptl.x = x; ptl.y = y;
   WinDrawBitmap( hps, hbmBtnCorner, NULL, &ptl,
                  ColorTop, ColorBottom, DBM_NORMAL );
   ptl.x = x+BtnWidth-BtnBorderX; ptl.y = y+BtnHeight-BtnBorderY;
   WinDrawBitmap( hps, hbmBtnCorner, NULL, &ptl,
                  ColorTop, ColorBottom, DBM_NORMAL );

   /* Draw the unique part of the part */
   if (BtnDown) {
      x += BtnBorderX; y -= BtnBorderY;
   } /* endif */
   rctl.xLeft   = x+3*BtnBorderX;
   rctl.yBottom = y+3*BtnBorderY;
   rctl.xRight  = x+BtnWidth-3*BtnBorderX;
   rctl.yTop    = rctl.yBottom+BtnTextHeight;
   WinDrawText( hps,
                -1,
                BtnList[ButtonID].BtnLabel,
                &rctl,
                SYSCLR_MENUTEXT,
                SYSCLR_BUTTONMIDDLE,
                DT_CENTER|DT_VCENTER | DT_MNEMONIC);

   ptl.x = x+3*BtnBorderX+1; ptl.y = rctl.yTop+BtnBorderY;
   WinDrawBitmap( hps, BtnList[ButtonID].Btnhbm, NULL, &ptl,
                  SYSCLR_MENUTEXT, SYSCLR_BUTTONMIDDLE, DBM_NORMAL );
} /* end of DrawButton */


