#define INCL_WIN
#include <os2.h>
#include "playback.h"
#include "hooks.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY MyDlgProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
HWND hwndEF;


INT main( VOID )
{
   HMQ     hmq;
   HAB     hab;
   QMSG    Qmsg;
   HWND    hwndDlg;
   SWP     swp;

   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   MyInit(hab);
   SetInputHook();

   hwndDlg = WinLoadDlg( HWND_DESKTOP, /* parent              */
                         NULLHANDLE,   /* no owner            */
                         MyDlgProc,    /* dialog window proc  */
                         NULLHANDLE,   /* module handle       */
                         IDD_DLG,      /* dialog template ID  */
                         NULL);        /* no app data         */

   hwndEF = WinWindowFromID(hwndDlg, IDD_EF);
   WinShowWindow(hwndEF, FALSE);

   /* find where system would place dialog box */
   WinQueryTaskSizePos( hab, 0, &swp );

   /* place dialog box at position given by the shell */
   WinSetWindowPos( hwndDlg,       /* change the dialog window's position */
                    NULLHANDLE,    /* ignored, SWP_ZORDER not set */
                    swp.x, swp.y,  /* position of lower left corner */
                    0, 0,          /* ignored SWP_SIZE not set */
                    SWP_SHOW       /* show dialog box */
                    | SWP_MOVE );  /* do not ignore swp.x and swp.y */

   WinSendMsg( hwndDlg,
               WM_SETICON,
               (MPARAM)WinQuerySysPointer( HWND_DESKTOP,
                                           SPTR_APPICON,
                                           FALSE ),
               NULL);

   WinProcessDlg( hwndDlg );
   ReleaseInputHook();

   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY MyDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   static USHORT usCurQ;

   switch ( msg ) {

      case WM_CONTROL:

         if (SHORT2FROMMP(mp1) == BN_CLICKED) {

            if ( SHORT1FROMMP(mp1) == IDD_RAD1 )
               usCurQ = 1;
            else if ( SHORT1FROMMP(mp1) == IDD_RAD2 )
               usCurQ = 2;
            break;
         }

         else if (SHORT2FROMMP(mp1) == EN_KILLFOCUS) {
            WinShowWindow(hwndEF, FALSE);
            WinSendMsg(hwndEF,                       /* Select all of the */
                       EM_SETSEL,                    /* text so it can be */
                       MPFROM2SHORT( 0, 0x7fff ),    /* deleted.          */
                       0);
            WinSendMsg(hwndEF,
                       EM_CLEAR,
                       0,
                       0);
            ReleaseRecordHook();
            break;
         }
         return WinDefDlgProc( hwnd, msg, mp1, mp2 );

      case WM_COMMAND:

         switch (SHORT1FROMMP(mp1)) {

            case IDD_START:
               WinShowWindow(hwndEF, TRUE);
               WinSetFocus(HWND_DESKTOP, hwndEF); /* Give Entry fld focus */
               SetRecordHook(usCurQ);
               break;

            case IDD_STOP:
               WinShowWindow(hwndEF, FALSE);
               WinSendMsg(hwndEF,                    /* Select all of the */
                          EM_SETSEL,                 /* text so it can be */
                          MPFROM2SHORT( 0, 0x7fff ), /* deleted.          */
                          0);
               WinSendMsg(hwndEF,
                          EM_CLEAR,
                          0,
                          0);
               ReleaseRecordHook();
               break;

            case DID_CANCEL:
               return FALSE;
               break;

            default:
               return WinDefDlgProc( hwnd, msg, mp1, mp2 );
         }
         break;

      case WM_CLOSE:
         WinDestroyWindow( hwnd );
         break;

      default:
         return WinDefDlgProc( hwnd, msg, mp1, mp2 );

   }

   return FALSE;
} /* end of MyDlgProc */
