#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include "presparm.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY MyDlgProc( HWND, ULONG, MPARAM, MPARAM );


INT main( VOID )
{
   HAB  hab;
   HMQ  hmq;
   QMSG qmsg;
   HWND hwndDlg;
   SWP  swp;

   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   hwndDlg = WinLoadDlg( HWND_DESKTOP,  /* set the desktop as parent */
                         NULLHANDLE,    /* no owner */
                         MyDlgProc,     /* address of dialog procedure */
                         NULLHANDLE,    /* use .EXE fill for resources */
                         ID_DLGBOX,     /* ID of the dialog box resource */
                         NULL );        /* no */

   /* find where system would place dialog box */
   WinQueryTaskSizePos( hab, 0, &swp );

   /* place dialog box at position given by the shell */
   WinSetWindowPos( hwndDlg,       /* change the dialog window's position */
                    NULLHANDLE,    /* ignored, SWP_ZORDER not set */
                    swp.x, swp.y,  /* position of lower left corner */
                    0, 0,          /* ignored SWP_SIZE not set */
                    SWP_SHOW       /* show dialog box */
                    | SWP_MOVE );  /* do not ignore swp.x and swp.y */

   if ( hwndDlg)
      while (WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndDlg );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY MyDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   static HWND hwndButton;
   static CHAR szSmall[] = "8.Helvetica";
   static CHAR szLarge[] = "40.Times New Roman Italic";
   static RGB2 aRGB[] = {    0,    0, 0xFF,  0, /* red */
                             0, 0xFF,    0,  0, /* green */
                          0xFF,    0,    0,  0 /* blue */
                        };

   switch(msg) {

   case WM_INITDLG:
      /* set an icon for the dialog */
      WinSendMsg( hwnd,
                  WM_SETICON,
                  (MPARAM)WinQuerySysPointer( HWND_DESKTOP,
                                              SPTR_APPICON,
                                              FALSE ),
                  NULL);

      /* set ID_LARGE as presently selected */
      WinSendDlgItemMsg ( hwnd,
                          ID_LARGE,
                          BM_SETCHECK,
                          MPFROM2SHORT (TRUE, 0),
                          NULL );

      /* set ID_RED as presently selected */
      WinSendDlgItemMsg ( hwnd,
                          ID_RED,
                          BM_SETCHECK,
                          MPFROM2SHORT (TRUE, 0),
                          NULL );

      /* store the handle to "My Button" */
      hwndButton = WinWindowFromID( hwnd, ID_BUTTON );
      break;

   case WM_CONTROL:
      switch (SHORT1FROMMP(mp1)) {
      case ID_RED:
      case ID_GREEN:
      case ID_BLUE:
         WinSetPresParam( hwndButton,
                          PP_FOREGROUNDCOLOR,
                          4, /* don't use sizeof( RGB ), too small == 3 */
                          (PVOID)&aRGB[ SHORT1FROMMP(mp1) - ID_RED ] );
         break;
      case ID_SMALL:
         WinSetPresParam( hwndButton,
                          PP_FONTNAMESIZE,
                          strlen(szSmall) + 1,
                          (PVOID)szSmall );
         break;
      case ID_LARGE:
         WinSetPresParam( hwndButton,
                          PP_FONTNAMESIZE,
                          strlen(szLarge) + 1,
                          (PVOID)szLarge );
         break;
      case ID_DEFAULT:
         WinRemovePresParam( hwndButton,
                             PP_FONTNAMESIZE );
         break;
      default:
         return WinDefDlgProc(hwnd, msg, mp1, mp2);
      }
      break;

   case WM_COMMAND:
      return (MRESULT)FALSE;

   case WM_CLOSE:
      WinPostMsg( hwnd, WM_QUIT, 0, 0 );
      return FALSE;

   default:
      return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }

   return (MRESULT)FALSE;
} /* end of MyDlgProc */
