#define INCL_WIN
#include <os2.h>
#include "prodinfo.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY MyDlgProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY MyProdInfo( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
HPOINTER hIcon;


INT main( VOID )
{
   HAB   hab;
   HMQ   hmq;
   HWND  hwndDlg;
   QMSG  qmsg;
   SWP   swp;

   hab = WinInitialize( 0 );

   hmq = WinCreateMsgQueue( hab, 0 );

   hIcon = WinLoadPointer( HWND_DESKTOP, 0, ID_ICON );

   hwndDlg = WinLoadDlg( HWND_DESKTOP,     /* parent                      */
                         HWND_DESKTOP,     /* owner                       */
                         (PFNWP)MyDlgProc, /* dialog window proc          */
                         0,                /* module handle               */
                         ID_DLG1,          /* dialog template ID          */
                         NULL);            /* no app data                 */

   /* find where system would place dialog box */
   WinQueryTaskSizePos( hab, 0, &swp );

   /* place dialog box at position given by the shell */
   WinSetWindowPos( hwndDlg,       /* change the dialog window's position */
                    NULLHANDLE,    /* ignored, SWP_ZORDER not set */
                    swp.x, swp.y,  /* position of lower left corner */
                    0, 0,          /* ignored SWP_SIZE not set */
                    SWP_SHOW       /* show dialog box */
                    | SWP_MOVE );  /* do not ignore swp.x and swp.y */

   WinSendMsg( hwndDlg, WM_SETICON, (MPARAM)hIcon, NULL);

   if ( hwndDlg )
      while (WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndDlg );   /* clean up */
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY MyDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{

   switch ( msg ) {

      case WM_COMMAND:
         switch (LOUSHORT(mp1)) {

            case ID_ABOUT:
               WinDlgBox( HWND_DESKTOP,     /* parent window handle       */
                          hwnd,             /* set owner                  */
                          MyProdInfo,       /* dialog procedure           */
                          NULLHANDLE,       /* module handle              */
                          ID_DLG2,          /* dialog identifier          */
                          NULL);            /* initialization data        */
               break;

            case ID_EXIT:
               WinPostMsg( hwnd, WM_QUIT, 0, 0 );
               return FALSE;
         }
         break;

      case WM_CLOSE:
         WinPostMsg( hwnd, WM_QUIT, 0, 0 );
         return FALSE;

      default:
         return WinDefDlgProc( hwnd, msg, mp1, mp2 );

   }

   return (MRESULT)FALSE;
} /* end of MyDlgProc */


MRESULT EXPENTRY MyProdInfo( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   switch ( msg ) {

   case WM_INITDLG:
    { HWND      hwndSysMenu;
      MENUITEM  mi;
      USHORT    MenuID;
      SHORT     PresentItem = 0;
      INT       NumberOfItems;

      hwndSysMenu = WinWindowFromID( hwndDlg, FID_SYSMENU );
      WinSendMsg( hwndSysMenu,
                  MM_QUERYITEM,
                  MPFROM2SHORT( SC_SYSMENU, FALSE ),
                  (MPARAM)&mi );
      NumberOfItems = (INT)WinSendMsg( mi.hwndSubMenu,
                                       MM_QUERYITEMCOUNT,
                                       NULL,
                                       NULL );
      while (NumberOfItems--) {
         MenuID = (USHORT)WinSendMsg( mi.hwndSubMenu,
                                      MM_ITEMIDFROMPOSITION,
                                      MPFROM2SHORT( PresentItem, TRUE ),
                                      NULL );
         switch (MenuID) {
         case SC_CLOSE:
         case SC_MOVE:
            PresentItem++;
            break;
         default:
            WinSendMsg( mi.hwndSubMenu,
                        MM_DELETEITEM,
                        MPFROM2SHORT( MenuID, TRUE ),
                        0 );
         }
      }
    } break;

   default:
      return WinDefDlgProc( hwndDlg, msg, mp1, mp2 );
   }

   return (MRESULT) FALSE;
} /* end of MyDlgProc */
