#define INCL_WIN
#include <os2.h>
#define ID_SLIDER 1
#define ID_TIMER  2


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY ClientWndProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
HAB  hab;
HWND hwndSlider;


INT main (VOID)
{
   HMQ  hmq;
   HWND hwndFrame;
   HWND hwndClient;
   QMSG qmsg;
   SLDCDATA sldcdata;
   ULONG ulSliderStyle;
   CHAR szTickText[5];
   ULONG i;
   HDC   hdc;
   RECTL rcl ;
   LONG  alScreen[2];
   CHAR  szClientClass[] = "Client Window";
   ULONG flCreateFlags = FCF_TITLEBAR      /* create: title bar control     */
                       | FCF_SYSMENU       /*         system menu control   */
                       | FCF_MINBUTTON     /*         minimize button       */
                       | FCF_BORDER        /* draw borders                  */
                       | FCF_SHELLPOSITION /* shell decides window position */
                       | FCF_TASKLIST;     /* title added to switch list    */

   hab = WinInitialize(0);

   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,            /* anchor block handle */
                     szClientClass,  /* class name */
                     ClientWndProc,  /* pointer to window procedure */
                     CS_SIZEREDRAW,  /* class style */
                     0 );            /* number of class data bytes */

   hwndFrame = WinCreateStdWindow(
                  HWND_DESKTOP,    /* parent */
                  0,               /* make window visible */
                  &flCreateFlags,  /* creation flags for frame window */
                  szClientClass,   /* client window class name */
                  "Progress Indicator", /* title bar text */
                  0,               /* use default client window style    */
                                   /*    WS_VISIBLE is not needed here */
                  NULLHANDLE,      /* resource ID's are in rc file */
                  0,               /* no ID for frame window */
                  &hwndClient );   /* address to place client window handle */

   WinSendMsg ( hwndFrame,
                WM_SETICON,
                (MPARAM)WinQuerySysPointer(HWND_DESKTOP, SPTR_APPICON, FALSE),
                NULL);

  hdc = WinOpenWindowDC(hwndFrame);

  DevQueryCaps( hdc,
                CAPS_WIDTH,
                2L,
                alScreen
              );

   WinSetWindowPos( hwndFrame,
                    NULLHANDLE,                       /* Z-order */
                    0,                                /* X coordinate */
                    0,                                /* Y coordinate */
                    alScreen[0]/3,                    /* X size */
                    alScreen[1]/2,                    /* Y size */
                    SWP_SHOW | SWP_SIZE) ;

   WinQueryWindowRect (hwndClient, &rcl) ;

   sldcdata.cbSize = sizeof(SLDCDATA);
   sldcdata.usScale1Increments = 11;    /* # of divisions on scale */
   sldcdata.usScale1Spacing = (rcl.yTop-rcl.yBottom-20)/10;

   ulSliderStyle = WS_VISIBLE      |
                   SLS_RIBBONSTRIP |    /* Fill with different color */
                   SLS_VERTICAL    |    /* Shaft will be vertical */
                   SLS_HOMEBOTTOM  |    /* Start on bottom */
                   SLS_OWNERDRAW   |    /* We will draw the ribbon */
                   SLS_READONLY;        /* Visual purposes only */

   hwndSlider = WinCreateWindow(
                 hwndClient,                 /* parent window handle */
                 WC_SLIDER,                  /* Window class */
                 (PSZ)NULL,                  /* title text */
                 ulSliderStyle,              /* style */
                 0,                          /* X position */
                 0,                          /* Y position */
                 rcl.xRight,                 /* X size */
                 rcl.yTop,                   /* Y size */
                 hwndClient,                 /* owner */
                 HWND_TOP,                   /* z-order */
                 ID_SLIDER,                  /* id */
                 &sldcdata,                  /* control data */
                 NULL);                      /* Presentation parms */


   WinSendMsg ( hwndSlider,
                SLM_SETTICKSIZE,
                MPFROM2SHORT (SMA_SETALLTICKS, 5),
                (MPARAM) NULL );


   for (i = 0; i <= 10; i++) {

      _itoa(i*10, szTickText, 10);
      strcat(szTickText, "%");

      WinSendMsg( hwndSlider,
                  SLM_SETSCALETEXT,
                  MPFROMSHORT( i ),
                  MPFROMP(szTickText) );
   } /* endfor */

   WinSendMsg( hwndSlider,
               SLM_SETSLIDERINFO,
               MPFROM2SHORT(SMA_SHAFTDIMENSIONS, 0),
               MPFROMLONG(rcl.xRight/8) );

   i = CLR_YELLOW;
   WinSetPresParam( hwndSlider,
                    PP_BACKGROUNDCOLORINDEX,
                    (ULONG)sizeof(LONG),
                    (PVOID)&i);

   if ( hwndFrame )
      while (WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndFrame );   /* clean up */
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end main */


MRESULT EXPENTRY ClientWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  static USHORT usPercentDone = 0;

  switch( msg ) {

  case WM_CREATE:
     WinStartTimer( hab,
                    hwnd,
                    ID_TIMER,
                    1000        /* Time in millisecs */
                  );
     break;

  case WM_DRAWITEM:

     if (((POWNERITEM)mp2)->idItem == SDA_RIBBONSTRIP) {
        WinFillRect(  ((POWNERITEM)mp2)->hps,
                      &((POWNERITEM)mp2)->rclItem,
                      CLR_BLUE
                   );
        return (MRESULT)TRUE;
     }
     else
        return (MRESULT)FALSE;

  case WM_TIMER:

     if( SHORT1FROMMP(mp1) == ID_TIMER ) {

        if(++usPercentDone > 10) {
           usPercentDone = 0;
        }

        WinSendMsg ( hwndSlider,
                     SLM_SETSLIDERINFO,
                     MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_INCREMENTVALUE),
                     MPFROMSHORT( usPercentDone ) );

        return (MRESULT)FALSE;
     }
     break;

  default:
    return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }

  return (MRESULT)FALSE;
} /* end of ClientWndProc */
