#define INCL_WIN
#define INCL_DOS
#define INCL_DOSEXCEPTIONS
#define INCL_ERRORS
#include <os2.h>
#include <string.h>
#include <setjmp.h>
#include "qbox.h"


/* function prototypes */
ULONG EXPENTRY XHandler( PEXCEPTIONREPORTRECORD,
                PEXCEPTIONREGISTRATIONRECORD,
                PCONTEXTRECORD,
                PVOID);
MRESULT EXPENTRY MyDlgProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
jmp_buf env;


APIRET EXPENTRY QBox( HWND hwndParent,
                      HWND hwndOwner,
                      PSZ pszTitle,
                      PSZ pszLabel,
                      PSZ pszBuffer,
                      ULONG ulLen )
{
   HMODULE hmod;
   HWND hwndDlg, hwndEF;
   PVOID pMem;
   EXCEPTIONREGISTRATIONRECORD XRegRec;

   XRegRec.ExceptionHandler = (_ERR * volatile)XHandler ;
   DosSetExceptionHandler((PEXCEPTIONREGISTRATIONRECORD)&XRegRec);

   if (setjmp(env)) {
      DosUnsetExceptionHandler(&XRegRec) ;
      return(APIRET)ERROR_INVALID_PARAMETER;
   }

   DosQueryModuleHandle( "QBOX", &hmod);
   hwndDlg = WinLoadDlg( hwndParent,    /* parent             */
                         hwndOwner,     /* owner              */
                         MyDlgProc,     /* dialog window proc */
                         hmod,          /* module handle      */
                         IDD_QBOX,      /* dialog template ID */
                         NULL);         /* no app data        */

   WinSetWindowText( hwndDlg, pszTitle);
   WinSetDlgItemText( hwndDlg, IDD_TEXT, pszLabel);

   hwndEF = WinWindowFromID(hwndDlg, IDD_EF);

   WinSendMsg(hwndEF,
              EM_SETTEXTLIMIT,
              MPFROMSHORT((SHORT)ulLen),
              0);

   WinProcessDlg(hwndDlg);

   DosAllocMem((PPVOID)&pMem,
               (ULONG)ulLen,
               (ULONG)PAG_READ | PAG_WRITE | PAG_COMMIT);

   WinQueryWindowText(hwndEF, ulLen, pMem);
   strcpy(pszBuffer, pMem);
   DosFreeMem(pMem);

   DosUnsetExceptionHandler(&XRegRec) ;

   return(APIRET)NO_ERROR;
} /* end of QBox */


ULONG EXPENTRY XHandler( PEXCEPTIONREPORTRECORD pXRepRec,
                PEXCEPTIONREGISTRATIONRECORD pRegRec,
                PCONTEXTRECORD  pContextRecord,
                PVOID pUnk)
{
   if ( pXRepRec->ExceptionNum == XCPT_ACCESS_VIOLATION)
      longjmp(env,1);
   else
      return XCPT_CONTINUE_SEARCH;
} /* end of XHandler */


MRESULT EXPENTRY MyDlgProc( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2 )
{

   switch ( msg ) {

      case WM_COMMAND:
         switch (LOUSHORT(mp1)) {

            case IDD_OK:
               return(MRESULT)(WinDismissDlg(hwndDlg, TRUE));
         }
         break;

      default:
         return WinDefDlgProc( hwndDlg, msg, mp1, mp2 );
   }

   return (MRESULT)FALSE;
} /* end of MyDlgProc */
