#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include "sysdlls.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY MyDlgProc( HWND, ULONG, MPARAM, MPARAM );
VOID MyPrfQuery( HWND );
VOID MyPrfWrite( HWND );


/* global variables */
CHAR szAppName[] = "SYS_DLLS";
CHAR szKeyName[] = "LoadOneTime";


INT main( VOID )
{
   HAB   hab;
   HMQ   hmq;
   QMSG  qmsg;
   HWND  hwndDlg;
   SWP   swp;

   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   hwndDlg = WinLoadDlg( HWND_DESKTOP,  /* set the desktop as parent      */
                         NULLHANDLE,    /* no owner                       */
                         MyDlgProc,     /* address of dialog procedure    */
                         NULLHANDLE,    /* use .EXE fill for resources    */
                         ID_DLGBOX,     /* ID of the dialog box resource  */
                         NULL );        /* no control data                */

   /* find where system would place dialog box */
   WinQueryTaskSizePos( hab, 0, &swp );

   /* place dialog box at position given by the shell */
   WinSetWindowPos( hwndDlg,       /* change the dialog window's position */
                    NULLHANDLE,    /* ignored, SWP_ZORDER not set */
                    swp.x, swp.y,  /* position of lower left corner */
                    0, 0,          /* ignored SWP_SIZE not set */
                    SWP_SHOW       /* show dialog box */
                    | SWP_MOVE );  /* do not ignore swp.x and swp.y */

   WinSendMsg( hwndDlg,
               WM_SETICON,
               (MPARAM)WinQuerySysPointer( HWND_DESKTOP,
                                           SPTR_APPICON,
                                           FALSE ),
               NULL);

   if ( hwndDlg)
      while (WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndDlg );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end main */


MRESULT EXPENTRY MyDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   switch(msg) {

      case WM_INITDLG:
         WinSendMsg( hwnd, WM_SETICON,
                     (MPARAM)WinLoadPointer( HWND_DESKTOP,
                                             NULLHANDLE,
                                             ID_DLGBOX ),
                     NULL );
         WinSendDlgItemMsg( hwnd, ID_ENTRYFIELD, EM_SETTEXTLIMIT,
                            MPFROMSHORT(1024), MPFROMLONG(0) );

         /* place value of SYS_DLLS : LoadPerProcess into ID_ENTRYFIELD */
         MyPrfQuery( hwnd );

         break;

      case WM_COMMAND:
         switch (SHORT1FROMMP(mp1)) {

            case ID_WRITE:
             /* place value in ID_ENTRYFIELD into SYS_DLLS : LoadPerprocess */
               MyPrfWrite( hwnd );
               break;

            case ID_QUERY:
             /* place value of SYS_DLLS : LoadPerProcess into ID_ENTRYFIELD */
               MyPrfQuery( hwnd );
               break;

            case DID_OK:
               WinPostMsg( hwnd, WM_QUIT, 0, 0 );
               return FALSE;
         }
         break;

      case WM_CLOSE:
         WinPostMsg( hwnd, WM_QUIT, 0, 0 );
         return FALSE;

      default:
         return(WinDefDlgProc(hwnd, msg, mp1, mp2));
   }

   return (MRESULT)FALSE;
} /* end MyDlgProc */


VOID MyPrfQuery( HWND hwnd )
{
   ULONG ulBuffer;
   CHAR  szErrorMessage[] = "<VALUE NOT FOUND>";
   PSZ   psz;

   PrfQueryProfileSize( HINI_USERPROFILE,
                        szAppName,
                        szKeyName,
                        &ulBuffer );

   /* allocate something atleast big enough for szErrorMessage */
   psz = (PSZ)malloc( ulBuffer + sizeof( szErrorMessage ) );

   if ( psz != NULL) {
      PrfQueryProfileString( HINI_USERPROFILE,
                             szAppName,
                             szKeyName,
                             szErrorMessage,
                             psz,
                             ulBuffer );
      WinSetDlgItemText( hwnd, ID_ENTRYFIELD, psz );
   }

   free( psz );
   return;
} /* end MyPrfQuery */


VOID MyPrfWrite( HWND hwnd )
{
   ULONG  ulBuffer;
   USHORT rc;
   PSZ    psz;

   rc = WinMessageBox( HWND_DESKTOP,  /* parent */
                  hwnd,               /* owner */
                  "This will change your os2.ini file.\nAre you sure?",
                  "Writing to os2.ini",
                  0,                         /* message box id */
                  MB_ICONHAND | MB_YESNO );  /* yes and no button with icon */

   if ( rc != MBID_YES )
      return;

   ulBuffer = WinQueryDlgItemTextLength( hwnd, ID_ENTRYFIELD ) + 1;

   /* allocate something to store the text */
   psz = (PSZ)malloc( ulBuffer );

   if ( psz != NULL) {
      WinQueryDlgItemText( hwnd, ID_ENTRYFIELD, ulBuffer, psz );

      PrfWriteProfileString( HINI_USERPROFILE,
                             szAppName,
                             szKeyName,
                             psz );
   }

   free( psz );
   return;
} /* end MyPrfWrite */

