#define INCL_WIN
#define INCL_DOS
#define INCL_ERRORS
#include <os2.h>
#include "testapp.h"
#include "qbox.h"


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY MyDlgProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
CHAR szBuffer[TEXT_LIMIT];


INT main( VOID )
{
   HAB      hab;
   HMQ      hmq;
   HWND     hwndDlg;
   HMODULE  hMod;
   SWP      swp;

   hab = WinInitialize( 0 );

   hmq = WinCreateMsgQueue( hab, 0 );

   DosLoadModule( NULL, 0, "QBOX", &hMod);

   hwndDlg = WinLoadDlg( HWND_DESKTOP,  /* parent             */
                         NULLHANDLE,    /* no owner           */
                         MyDlgProc,     /* dialog window proc */
                         NULLHANDLE,    /* module handle      */
                         IDD_MYDLG,     /* dialog template ID */
                         NULL);         /* no app data        */

   /* find where system would place dialog box */
   WinQueryTaskSizePos( hab, 0, &swp );

   /* place dialog box at position given by the shell */
   WinSetWindowPos( hwndDlg,       /* change the dialog window's position */
                    NULLHANDLE,    /* ignored, SWP_ZORDER not set */
                    swp.x, swp.y,  /* position of lower left corner */
                    0, 0,          /* ignored SWP_SIZE not set */
                    SWP_SHOW       /* show dialog box */
                    | SWP_MOVE );  /* do not ignore swp.x and swp.y */


   WinSendMsg( hwndDlg,
               WM_SETICON,
               (MPARAM)WinQuerySysPointer( HWND_DESKTOP,
                                           SPTR_APPICON,
                                           FALSE ),
               NULL);

   WinProcessDlg( hwndDlg );

   DosFreeModule( hMod );

   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end of main */


MRESULT EXPENTRY MyDlgProc( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2 )
{

   switch ( msg ) {

      case WM_COMMAND:
         switch (LOUSHORT(mp1)) {

            case IDB_LEGAL:
             { APIRET rc;

               rc = QBox( HWND_DESKTOP,
                          hwndDlg,
                          "Query Box DLL",
                          "Enter Name:",
                          szBuffer,
                          TEXT_LIMIT);

               if (rc == NO_ERROR)
                  WinMessageBox( HWND_DESKTOP,
                                 HWND_DESKTOP,
                                 szBuffer,
                                 "Name Returned",
                                 0,
                                 MB_OK
                               );
             } break;

            case IDB_ILLEGAL:
             { APIRET rc;

               rc = QBox( HWND_DESKTOP,
                          hwndDlg,
                          "Query Box DLL",
                          "Enter name:",
                          NULL,           /* NULL is an invalid parameter */
                          TEXT_LIMIT);

               if (rc != NO_ERROR)
                  WinMessageBox( HWND_DESKTOP,
                                 HWND_DESKTOP,
                                 "Exception handler worked!",
                                 "Invalid Pointer Test",
                                 0,
                                 MB_OK
                               );

             } break;

            case IDB_EXIT:
               WinDestroyWindow( hwndDlg );
               break;

         }
         break;

      case WM_CLOSE:
         WinDestroyWindow( hwndDlg );
         break;

      default:
         return WinDefDlgProc( hwndDlg, msg, mp1, mp2 );
   }

   return (MRESULT)FALSE;
} /* end of MyDlgProc */
