#define INCL_DOS
#define INCL_WIN
#include <os2.h>
#include "titlebar.h"

#pragma data_seg( MY_SHARED_DATA )

/* prototypes */
INT main( VOID );
MRESULT EXPENTRY MyWndProc( HWND, ULONG, MPARAM, MPARAM );

/* globals */
static BOOL Init = FALSE;
static CLASSINFO  fci;


INT main( VOID )
{
   if ( !Init ) {
      Init = TRUE;

      if (!WinQueryClassInfo( NULLHANDLE, WC_TITLEBAR, &fci )) {
         WinAlarm( HWND_DESKTOP, WA_ERROR );
         return 1; /* tell PM not to continue with this DLL */
      }

      if (!WinRegisterClass(
              NULLHANDLE,     /* anchor block handle */
              WC_TITLEBAR,    /* class name */
              MyWndProc,      /* pointer to window procedure */
              fci.flClassStyle | CS_PUBLIC,       /* class style */
              fci.cbWindowData + sizeof(HWND) ))  /* number of data bytes */
      {
         WinAlarm( HWND_DESKTOP, WA_ERROR );
         return 1; /* tell PM not to continue with this DLL */
      }
   }
   return 0;
} /* end main */


MRESULT EXPENTRY MyWndProc( HWND hwnd,
                            ULONG msg,
                            MPARAM mp1,
                            MPARAM mp2 )
{

   switch(msg) {

   case WM_CREATE:
    { HMODULE hmod;
      HWND    hwndMenu;

      DosLoadModule( NULL, 0, "TITLEBAR", &hmod );

      hwndMenu = WinLoadMenu( HWND_OBJECT, hmod, ID_TITLEBAR );

      DosFreeModule( hmod );

      /* change the window ID from FID_MENU to ID_TITLEBAR */
      WinSetWindowUShort( hwndMenu, QWS_ID, ID_TITLEBAR );

      /* store hwndMenu in title bar window data */
      WinSetWindowULong( hwnd, fci.cbWindowData, (ULONG)hwndMenu );

      return (MRESULT)(*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );
    } break;

   case WM_COMMAND:
      switch (SHORT1FROMMP(mp1)) {
      default:
         return (MRESULT)(*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );
      }
      return FALSE;

   case WM_BUTTON2DOWN:
    { POINTL  ptl;
      HWND    hwndMenu;

      WinQueryPointerPos( HWND_DESKTOP, &ptl );

      hwndMenu = (HWND)WinQueryWindowULong( hwnd, fci.cbWindowData );

      WinPopupMenu( HWND_DESKTOP,
                    WinQueryWindow( hwnd, QW_PARENT ),
                    hwndMenu,
                    ptl.x,
                    ptl.y,
                    0,
                    PU_NONE
                    | PU_HCONSTRAIN   | PU_VCONSTRAIN
                    | PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2
                    | PU_KEYBOARD );

      return FALSE;
    } break;

   case WM_DESTROY:
    { POINTL  ptl;
      HWND    hwndMenu;

      hwndMenu = (HWND)WinQueryWindowULong( hwnd, fci.cbWindowData );

      WinDestroyWindow( hwndMenu );
    } /* fall through to default */

   default:
      return (MRESULT)(*fci.pfnWindowProc)( hwnd, msg, mp1, mp2 );
   }
   return FALSE;
} /* MyWndProc */

