#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include "trckrect.h"


/* prototypes */
INT main( VOID );
MRESULT EXPENTRY NewFrameWndProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY ClientWinProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
PFNWP OldFrameWndProc = NULL;


INT main( VOID )
{
   HAB  hab;
   HMQ  hmq;
   QMSG qmsg;
   HWND hwndFrame;
   HWND hwndClient;
   static CHAR szClientClass[] = "Client Window";
   ULONG flCreateFlags = FCF_TITLEBAR      /* create: title bar control     */
                       | FCF_SYSMENU       /*         system menu control   */
                       | FCF_SIZEBORDER    /*         sizeborders           */
                       | FCF_MINMAX        /*         min and max buttons   */
                       | FCF_SHELLPOSITION /* shell decides window position */
                       | FCF_TASKLIST      /* title added to switch list    */
                       | FCF_ICON;         /* frame has an icon             */

   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab,            /* anchor block handle */
                     szClientClass,  /* class name */
                     ClientWinProc,  /* pointer to window procedure */
                     CS_SIZEREDRAW,  /* class style */
                     0 );            /* number of control data bytes */

   hwndFrame = WinCreateStdWindow(
                  HWND_DESKTOP,    /* parent        */
                  0,               /* window style  */
                  &flCreateFlags,  /* creation flags for frame window       */
                  szClientClass,   /* client window class name              */
                  "Tracking Rectangle",  /* title bar text                  */
                  0,               /* use default client window style       */
                                   /*    WS_VISIBLE is not needed here      */
                  NULLHANDLE,      /* resource ID's are in rc file          */
                  ID_TRCKRECT,     /* ID for frame window and its resources */
                  &hwndClient );   /* address to place client window handle */

   OldFrameWndProc = WinSubclassWindow( hwndFrame, NewFrameWndProc );

   WinShowWindow( hwndFrame, TRUE );

   if ( hwndFrame )
      while (WinGetMsg(hab,&qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg(hab, &qmsg);

   WinDestroyWindow( hwndFrame );  /* clean up */
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   return 0;
} /* end main */


MRESULT EXPENTRY NewFrameWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg) {

   //
   //  message handling for modifying the frame's properties
   //

   case WM_QUERYTRACKINFO:
     /* let original frame window procedure fill the TRACKINFO structure */
      OldFrameWndProc( hwnd, msg, mp1, mp2 );

     /* modify the data in the TRACKINFO structure */
      ((PTRACKINFO)mp2)->cxBorder *= 2; /* double thickness of the lines */
      ((PTRACKINFO)mp2)->cyBorder *= 2;

      ((PTRACKINFO)mp2)->ptlMinTrackSize.x *= 2; /* double the minimum size */
      ((PTRACKINFO)mp2)->ptlMinTrackSize.y *= 2;

      return (MRESULT)TRUE; /* continue with repositioning window */

   default:
      /* call original frame window procedure */
      return (MRESULT)(*OldFrameWndProc)(hwnd, msg, mp1, mp2);
   }

   return (MRESULT)FALSE;
} /* NewFrameWndProc */


MRESULT EXPENTRY ClientWinProc( HWND hwnd, ULONG msg, MPARAM mp1,MPARAM mp2 )
{
   switch (msg) {

   case WM_ERASEBACKGROUND:
      /* have the frame paint the client window */
      return (MRESULT) TRUE;

   default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
   }

   return (MRESULT)FALSE;
} /* ClientWinProc */

