#define INCL_WIN
#include <os2.h>
#define NUM_SYSBMAPS  48


/* function prototypes */
INT main( VOID );
MRESULT EXPENTRY MyFrameProc( HWND, ULONG, MPARAM, MPARAM );


/* global variables */
PFNWP OldFrameProc;
HWND hwndVSet;


INT main( VOID )
{
   HAB  hab;
   HMQ  hmq;
   HWND hwndFrame;
   QMSG qmsg;
   USHORT row = 1, col = 1;
   VSCDATA vscData;
   ULONG ulVSetStyle;
   ULONG i;
   FRAMECDATA fcd;

   fcd.cb = sizeof(FRAMECDATA);           /* length of structure          */
   fcd.flCreateFlags =  FCF_TITLEBAR      /* create: title bar control    */
                      | FCF_SYSMENU       /*         system menu control  */
                      | FCF_SIZEBORDER    /*         sizeborders          */
                      | FCF_MINMAX        /*         min and max buttons  */
                      | FCF_SHELLPOSITION /* shell decides window pos     */
                      | FCF_TASKLIST;     /* title added to switch list   */
   fcd.hmodResources = NULLHANDLE;        /* Handle to a module           */
   fcd.idResources   = 0;                 /* identifier for the frame     */

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue( hab, 0 );

   hwndFrame  = WinCreateWindow(
                   HWND_DESKTOP,     /* parent window is the desktop      */
                   WC_FRAME,         /* class name                        */
                   "System Bitmaps", /* text added to title bar           */
                   0,                /* window style                      */
                   0, 0, 0, 0,       /* ignored, FCF_SHELLPOSITION set    */
                   NULLHANDLE,       /* no owner window                   */
                   HWND_TOP,         /* on top of Desktop's children      */
                   0,                /* ID number for frame resources     */
                   &fcd,             /* data unique for frame windows     */
                   NULL );           /* no presentation parameters        */

   WinSendMsg ( hwndFrame,
                WM_SETICON,
                (MPARAM)WinQuerySysPointer( HWND_DESKTOP,
                                            SPTR_APPICON,
                                            FALSE),
                NULL);

   vscData.cbSize = sizeof(VSCDATA);
   vscData.usRowCount = 7;
   vscData.usColumnCount = 7;

   ulVSetStyle = VS_BITMAP | VS_ITEMBORDER;

   /* Now create the value set window. */
   hwndVSet = WinCreateWindow(
                 hwndFrame,    /* parent window handle      */
                 WC_VALUESET,  /* window class              */
                 NULL,         /* no window text            */
                 ulVSetStyle,  /* style                     */
                 0, 0, 0, 0,   /* ignored, frame will pos   */
                 hwndFrame,    /* owner                     */
                 HWND_BOTTOM,  /* z-order                   */
                 FID_CLIENT,   /* ID                        */
                 &vscData,     /* control data              */
                 NULL);        /* no presentation parms     */

   for (i = 1; i <= NUM_SYSBMAPS; i++) {

      WinSendMsg( hwndVSet,
                  VM_SETITEM,
                  MPFROM2SHORT(row,col),
                  MPFROMLONG( WinGetSysBitmap( HWND_DESKTOP, i )));

      if(++col >= 8) {
         col = 1;
         ++row;
      }
   }

   OldFrameProc = WinSubclassWindow( hwndFrame, MyFrameProc );

   WinSetWindowText( hwndFrame, "Row 1 Column 1");

   WinShowWindow( hwndFrame, TRUE );

   if ( hwndFrame )
      while( WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
         WinDispatchMsg( hab, &qmsg );

   WinDestroyWindow( hwndFrame );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

} /* End of main */


MRESULT EXPENTRY MyFrameProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{

   switch( msg ) {

      case WM_CONTROL:

         if (SHORT2FROMMP(mp1) == VN_SELECT)
         {  ULONG ulRowCol;
            CHAR  szBuffer[20];

            ulRowCol = (ULONG)WinSendMsg( hwndVSet,
                                          VM_QUERYSELECTEDITEM,
                                          NULL,
                                          NULL );

            sprintf( szBuffer, "Row %d Column %d",
                     SHORT1FROMMP(ulRowCol),
                     SHORT2FROMMP(ulRowCol) );

            WinSetWindowText( hwnd, szBuffer);

            return (MRESULT)FALSE;
         }
   }

   return (MRESULT)(*OldFrameProc)( hwnd, msg, mp1, mp2 );
} /* end of MyFrameProc */
